typedef unsigned int size_t;
typedef int wchar_t;


typedef struct
  {
    int quot;
    int rem;
  } div_t;
typedef struct
  {
    long int quot;
    long int rem;
  } ldiv_t;

extern size_t __ctype_get_mb_cur_max (void) __attribute__ ((__nothrow__));

extern double atof (__const char *__nptr)
     __attribute__ ((__nothrow__)) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern int atoi (__const char *__nptr)
     __attribute__ ((__nothrow__)) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern long int atol (__const char *__nptr)
     __attribute__ ((__nothrow__)) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));


__extension__ extern long long int atoll (__const char *__nptr)
     __attribute__ ((__nothrow__)) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));


extern double strtod (__const char *__restrict __nptr,
        char **__restrict __endptr) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));


extern long int strtol (__const char *__restrict __nptr,
   char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern unsigned long int strtoul (__const char *__restrict __nptr,
      char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));

__extension__
extern long long int strtoq (__const char *__restrict __nptr,
        char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
__extension__
extern unsigned long long int strtouq (__const char *__restrict __nptr,
           char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));

__extension__
extern long long int strtoll (__const char *__restrict __nptr,
         char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
__extension__
extern unsigned long long int strtoull (__const char *__restrict __nptr,
     char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));

extern double __strtod_internal (__const char *__restrict __nptr,
     char **__restrict __endptr, int __group)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern float __strtof_internal (__const char *__restrict __nptr,
    char **__restrict __endptr, int __group)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern long double __strtold_internal (__const char *__restrict __nptr,
           char **__restrict __endptr,
           int __group) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern long int __strtol_internal (__const char *__restrict __nptr,
       char **__restrict __endptr,
       int __base, int __group)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern unsigned long int __strtoul_internal (__const char *__restrict __nptr,
          char **__restrict __endptr,
          int __base, int __group)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
__extension__
extern long long int __strtoll_internal (__const char *__restrict __nptr,
      char **__restrict __endptr,
      int __base, int __group)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
__extension__
extern unsigned long long int __strtoull_internal (__const char *
         __restrict __nptr,
         char **__restrict __endptr,
         int __base, int __group)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern char *l64a (long int __n) __attribute__ ((__nothrow__));
extern long int a64l (__const char *__s)
     __attribute__ ((__nothrow__)) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));

typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
__extension__ typedef signed long long int __int64_t;
__extension__ typedef unsigned long long int __uint64_t;
__extension__ typedef long long int __quad_t;
__extension__ typedef unsigned long long int __u_quad_t;
__extension__ typedef __u_quad_t __dev_t;
__extension__ typedef unsigned int __uid_t;
__extension__ typedef unsigned int __gid_t;
__extension__ typedef unsigned long int __ino_t;
__extension__ typedef __u_quad_t __ino64_t;
__extension__ typedef unsigned int __mode_t;
__extension__ typedef unsigned int __nlink_t;
__extension__ typedef long int __off_t;
__extension__ typedef __quad_t __off64_t;
__extension__ typedef int __pid_t;
__extension__ typedef struct { int __val[2]; } __fsid_t;
__extension__ typedef long int __clock_t;
__extension__ typedef unsigned long int __rlim_t;
__extension__ typedef __u_quad_t __rlim64_t;
__extension__ typedef unsigned int __id_t;
__extension__ typedef long int __time_t;
__extension__ typedef unsigned int __useconds_t;
__extension__ typedef long int __suseconds_t;
__extension__ typedef int __daddr_t;
__extension__ typedef long int __swblk_t;
__extension__ typedef int __key_t;
__extension__ typedef int __clockid_t;
__extension__ typedef int __timer_t;
__extension__ typedef long int __blksize_t;
__extension__ typedef long int __blkcnt_t;
__extension__ typedef __quad_t __blkcnt64_t;
__extension__ typedef unsigned long int __fsblkcnt_t;
__extension__ typedef __u_quad_t __fsblkcnt64_t;
__extension__ typedef unsigned long int __fsfilcnt_t;
__extension__ typedef __u_quad_t __fsfilcnt64_t;
__extension__ typedef int __ssize_t;
typedef __off64_t __loff_t;
typedef __quad_t *__qaddr_t;
typedef char *__caddr_t;
__extension__ typedef int __intptr_t;
__extension__ typedef unsigned int __socklen_t;
typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;
typedef __loff_t loff_t;
typedef __ino_t ino_t;
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __uid_t uid_t;
typedef __off_t off_t;
typedef __pid_t pid_t;
typedef __id_t id_t;
typedef __ssize_t ssize_t;
typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;

typedef __time_t time_t;


typedef __clockid_t clockid_t;
typedef __timer_t timer_t;
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;
typedef int int8_t __attribute__ ((__mode__ (__QI__)));
typedef int int16_t __attribute__ ((__mode__ (__HI__)));
typedef int int32_t __attribute__ ((__mode__ (__SI__)));
typedef int int64_t __attribute__ ((__mode__ (__DI__)));
typedef unsigned int u_int8_t __attribute__ ((__mode__ (__QI__)));
typedef unsigned int u_int16_t __attribute__ ((__mode__ (__HI__)));
typedef unsigned int u_int32_t __attribute__ ((__mode__ (__SI__)));
typedef unsigned int u_int64_t __attribute__ ((__mode__ (__DI__)));
typedef int register_t __attribute__ ((__mode__ (__word__)));
typedef int __sig_atomic_t;
typedef struct
  {
    unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
  } __sigset_t;
typedef __sigset_t sigset_t;
struct timespec
  {
    __time_t tv_sec;
    long int tv_nsec;
  };
struct timeval
  {
    __time_t tv_sec;
    __suseconds_t tv_usec;
  };
typedef __suseconds_t suseconds_t;
typedef long int __fd_mask;
typedef struct
  {
    __fd_mask __fds_bits[1024 / (8 * sizeof (__fd_mask))];
  } fd_set;
typedef __fd_mask fd_mask;

extern int select (int __nfds, fd_set *__restrict __readfds,
     fd_set *__restrict __writefds,
     fd_set *__restrict __exceptfds,
     struct timeval *__restrict __timeout);

__extension__
extern __inline unsigned int gnu_dev_major (unsigned long long int __dev)
     __attribute__ ((__nothrow__));
__extension__
extern __inline unsigned int gnu_dev_minor (unsigned long long int __dev)
     __attribute__ ((__nothrow__));
__extension__
extern __inline unsigned long long int gnu_dev_makedev (unsigned int __major,
       unsigned int __minor)
     __attribute__ ((__nothrow__));
__extension__ extern __inline unsigned int
__attribute__ ((__nothrow__)) gnu_dev_major (unsigned long long int __dev)
{
  return ((__dev >> 8) & 0xfff) | ((unsigned int) (__dev >> 32) & ~0xfff);
}
__extension__ extern __inline unsigned int
__attribute__ ((__nothrow__)) gnu_dev_minor (unsigned long long int __dev)
{
  return (__dev & 0xff) | ((unsigned int) (__dev >> 12) & ~0xff);
}
__extension__ extern __inline unsigned long long int
__attribute__ ((__nothrow__)) gnu_dev_makedev (unsigned int __major, unsigned int __minor)
{
  return ((__minor & 0xff) | ((__major & 0xfff) << 8)
   | (((unsigned long long int) (__minor & ~0xff)) << 12)
   | (((unsigned long long int) (__major & ~0xfff)) << 32));
}
typedef __blkcnt_t blkcnt_t;
typedef __fsblkcnt_t fsblkcnt_t;



typedef __fsfilcnt_t fsfilcnt_t;
struct __sched_param
  {
    int __sched_priority;
  };
typedef int __atomic_lock_t;
struct _pthread_fastlock
{
  long int __status;
  __atomic_lock_t __spinlock;
};
typedef struct _pthread_descr_struct *_pthread_descr;
typedef struct __pthread_attr_s
{
  int __detachstate;
  int __schedpolicy;
  struct __sched_param __schedparam;
  int __inheritsched;
  int __scope;
  size_t __guardsize;
  int __stackaddr_set;
  void *__stackaddr;
  size_t __stacksize;
} pthread_attr_t;
__extension__ typedef long long __pthread_cond_align_t;
typedef struct
{
  struct _pthread_fastlock __c_lock;
  _pthread_descr __c_waiting;
  char __padding[48 - sizeof (struct _pthread_fastlock)
   - sizeof (_pthread_descr) - sizeof (__pthread_cond_align_t)];
  __pthread_cond_align_t __align;
} pthread_cond_t;
typedef struct
{
  int __dummy;
} pthread_condattr_t;
typedef unsigned int pthread_key_t;
typedef struct
{
  int __m_reserved;
  int __m_count;
  _pthread_descr __m_owner;
  int __m_kind;
  struct _pthread_fastlock __m_lock;
} pthread_mutex_t;
typedef struct
{
  int __mutexkind;
} pthread_mutexattr_t;
typedef int pthread_once_t;
typedef unsigned long int pthread_t;

extern long int random (void) __attribute__ ((__nothrow__));
extern void srandom (unsigned int __seed) __attribute__ ((__nothrow__));
extern char *initstate (unsigned int __seed, char *__statebuf,
   size_t __statelen) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (2)));
extern char *setstate (char *__statebuf) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
struct random_data
  {
    int32_t *fptr;
    int32_t *rptr;
    int32_t *state;
    int rand_type;
    int rand_deg;
    int rand_sep;
    int32_t *end_ptr;
  };
extern int random_r (struct random_data *__restrict __buf,
       int32_t *__restrict __result) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int srandom_r (unsigned int __seed, struct random_data *__buf)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (2)));
extern int initstate_r (unsigned int __seed, char *__restrict __statebuf,
   size_t __statelen,
   struct random_data *__restrict __buf)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (2, 4)));
extern int setstate_r (char *__restrict __statebuf,
         struct random_data *__restrict __buf)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));

extern int rand (void) __attribute__ ((__nothrow__));
extern void srand (unsigned int __seed) __attribute__ ((__nothrow__));

extern int rand_r (unsigned int *__seed) __attribute__ ((__nothrow__));
extern double drand48 (void) __attribute__ ((__nothrow__));
extern double erand48 (unsigned short int __xsubi[3]) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern long int lrand48 (void) __attribute__ ((__nothrow__));
extern long int nrand48 (unsigned short int __xsubi[3])
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern long int mrand48 (void) __attribute__ ((__nothrow__));
extern long int jrand48 (unsigned short int __xsubi[3])
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern void srand48 (long int __seedval) __attribute__ ((__nothrow__));
extern unsigned short int *seed48 (unsigned short int __seed16v[3])
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern void lcong48 (unsigned short int __param[7]) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
struct drand48_data
  {
    unsigned short int __x[3];
    unsigned short int __old_x[3];
    unsigned short int __c;
    unsigned short int __init;
    unsigned long long int __a;
  };
extern int drand48_r (struct drand48_data *__restrict __buffer,
        double *__restrict __result) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int erand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        double *__restrict __result) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int lrand48_r (struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int nrand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int mrand48_r (struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int jrand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int srand48_r (long int __seedval, struct drand48_data *__buffer)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (2)));
extern int seed48_r (unsigned short int __seed16v[3],
       struct drand48_data *__buffer) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int lcong48_r (unsigned short int __param[7],
        struct drand48_data *__buffer)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));

extern void *malloc (size_t __size) __attribute__ ((__nothrow__)) __attribute__ ((__malloc__));
extern void *calloc (size_t __nmemb, size_t __size)
     __attribute__ ((__nothrow__)) __attribute__ ((__malloc__));


extern void *realloc (void *__ptr, size_t __size) __attribute__ ((__nothrow__)) __attribute__ ((__malloc__));
extern void free (void *__ptr) __attribute__ ((__nothrow__));

extern void cfree (void *__ptr) __attribute__ ((__nothrow__));

extern void *alloca (size_t __size) __attribute__ ((__nothrow__));

extern void *valloc (size_t __size) __attribute__ ((__nothrow__)) __attribute__ ((__malloc__));

extern void abort (void) __attribute__ ((__nothrow__)) __attribute__ ((__noreturn__));
extern int atexit (void (*__func) (void)) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));

extern int on_exit (void (*__func) (int __status, void *__arg), void *__arg)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));

extern void exit (int __status) __attribute__ ((__nothrow__)) __attribute__ ((__noreturn__));


extern char *getenv (__const char *__name) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));

extern char *__secure_getenv (__const char *__name) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int putenv (char *__string) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int setenv (__const char *__name, __const char *__value, int __replace)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (2)));
extern int unsetenv (__const char *__name) __attribute__ ((__nothrow__));
extern int clearenv (void) __attribute__ ((__nothrow__));
extern char *mktemp (char *__template) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int mkstemp (char *__template) __attribute__ ((__nonnull__ (1)));
extern char *mkdtemp (char *__template) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));

extern int system (__const char *__command);

extern char *realpath (__const char *__restrict __name,
         char *__restrict __resolved) __attribute__ ((__nothrow__));
typedef int (*__compar_fn_t) (__const void *, __const void *);

extern void *bsearch (__const void *__key, __const void *__base,
        size_t __nmemb, size_t __size, __compar_fn_t __compar)
     __attribute__ ((__nonnull__ (1, 2, 5)));
extern void qsort (void *__base, size_t __nmemb, size_t __size,
     __compar_fn_t __compar) __attribute__ ((__nonnull__ (1, 4)));
extern int abs (int __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern long int labs (long int __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));


extern div_t div (int __numer, int __denom)
     __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern ldiv_t ldiv (long int __numer, long int __denom)
     __attribute__ ((__nothrow__)) __attribute__ ((__const__));

extern char *ecvt (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3, 4)));
extern char *fcvt (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3, 4)));
extern char *gcvt (double __value, int __ndigit, char *__buf)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3)));
extern char *qecvt (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3, 4)));
extern char *qfcvt (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3, 4)));
extern char *qgcvt (long double __value, int __ndigit, char *__buf)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3)));
extern int ecvt_r (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign, char *__restrict __buf,
     size_t __len) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int fcvt_r (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign, char *__restrict __buf,
     size_t __len) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int qecvt_r (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign,
      char *__restrict __buf, size_t __len)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int qfcvt_r (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign,
      char *__restrict __buf, size_t __len)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (3, 4, 5)));

extern int mblen (__const char *__s, size_t __n) __attribute__ ((__nothrow__));
extern int mbtowc (wchar_t *__restrict __pwc,
     __const char *__restrict __s, size_t __n) __attribute__ ((__nothrow__));
extern int wctomb (char *__s, wchar_t __wchar) __attribute__ ((__nothrow__));
extern size_t mbstowcs (wchar_t *__restrict __pwcs,
   __const char *__restrict __s, size_t __n) __attribute__ ((__nothrow__));
extern size_t wcstombs (char *__restrict __s,
   __const wchar_t *__restrict __pwcs, size_t __n)
     __attribute__ ((__nothrow__));

extern int rpmatch (__const char *__response) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int getloadavg (double __loadavg[], int __nelem)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));



typedef struct _IO_FILE FILE;


typedef struct _IO_FILE __FILE;
typedef unsigned int wint_t;
typedef struct
{
  int __count;
  union
  {
    wint_t __wch;
    char __wchb[4];
  } __value;
} __mbstate_t;
typedef struct
{
  __off_t __pos;
  __mbstate_t __state;
} _G_fpos_t;
typedef struct
{
  __off64_t __pos;
  __mbstate_t __state;
} _G_fpos64_t;
enum
{
  __GCONV_OK = 0,
  __GCONV_NOCONV,
  __GCONV_NODB,
  __GCONV_NOMEM,
  __GCONV_EMPTY_INPUT,
  __GCONV_FULL_OUTPUT,
  __GCONV_ILLEGAL_INPUT,
  __GCONV_INCOMPLETE_INPUT,
  __GCONV_ILLEGAL_DESCRIPTOR,
  __GCONV_INTERNAL_ERROR
};
enum
{
  __GCONV_IS_LAST = 0x0001,
  __GCONV_IGNORE_ERRORS = 0x0002
};
struct __gconv_step;
struct __gconv_step_data;
struct __gconv_loaded_object;
struct __gconv_trans_data;
typedef int (*__gconv_fct) (struct __gconv_step *, struct __gconv_step_data *,
       __const unsigned char **, __const unsigned char *,
       unsigned char **, size_t *, int, int);
typedef wint_t (*__gconv_btowc_fct) (struct __gconv_step *, unsigned char);
typedef int (*__gconv_init_fct) (struct __gconv_step *);
typedef void (*__gconv_end_fct) (struct __gconv_step *);
typedef int (*__gconv_trans_fct) (struct __gconv_step *,
      struct __gconv_step_data *, void *,
      __const unsigned char *,
      __const unsigned char **,
      __const unsigned char *, unsigned char **,
      size_t *);
typedef int (*__gconv_trans_context_fct) (void *, __const unsigned char *,
       __const unsigned char *,
       unsigned char *, unsigned char *);
typedef int (*__gconv_trans_query_fct) (__const char *, __const char ***,
     size_t *);
typedef int (*__gconv_trans_init_fct) (void **, const char *);
typedef void (*__gconv_trans_end_fct) (void *);
struct __gconv_trans_data
{
  __gconv_trans_fct __trans_fct;
  __gconv_trans_context_fct __trans_context_fct;
  __gconv_trans_end_fct __trans_end_fct;
  void *__data;
  struct __gconv_trans_data *__next;
};
struct __gconv_step
{
  struct __gconv_loaded_object *__shlib_handle;
  __const char *__modname;
  int __counter;
  char *__from_name;
  char *__to_name;
  __gconv_fct __fct;
  __gconv_btowc_fct __btowc_fct;
  __gconv_init_fct __init_fct;
  __gconv_end_fct __end_fct;
  int __min_needed_from;
  int __max_needed_from;
  int __min_needed_to;
  int __max_needed_to;
  int __stateful;
  void *__data;
};
struct __gconv_step_data
{
  unsigned char *__outbuf;
  unsigned char *__outbufend;
  int __flags;
  int __invocation_counter;
  int __internal_use;
  __mbstate_t *__statep;
  __mbstate_t __state;
  struct __gconv_trans_data *__trans;
};
typedef struct __gconv_info
{
  size_t __nsteps;
  struct __gconv_step *__steps;
  __extension__ struct __gconv_step_data __data [];
} *__gconv_t;
typedef union
{
  struct __gconv_info __cd;
  struct
  {
    struct __gconv_info __cd;
    struct __gconv_step_data __data;
  } __combined;
} _G_iconv_t;
typedef int _G_int16_t __attribute__ ((__mode__ (__HI__)));
typedef int _G_int32_t __attribute__ ((__mode__ (__SI__)));
typedef unsigned int _G_uint16_t __attribute__ ((__mode__ (__HI__)));
typedef unsigned int _G_uint32_t __attribute__ ((__mode__ (__SI__)));
typedef __builtin_va_list __gnuc_va_list;
struct _IO_jump_t; struct _IO_FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
enum __codecvt_result
{
  __codecvt_ok,
  __codecvt_partial,
  __codecvt_error,
  __codecvt_noconv
};
struct _IO_FILE {
  int _flags;
  char* _IO_read_ptr;
  char* _IO_read_end;
  char* _IO_read_base;
  char* _IO_write_base;
  char* _IO_write_ptr;
  char* _IO_write_end;
  char* _IO_buf_base;
  char* _IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _flags2;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  int _mode;
  char _unused2[15 * sizeof (int) - 2 * sizeof (void *)];
};
typedef struct _IO_FILE _IO_FILE;
struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_2_1_stdin_;
extern struct _IO_FILE_plus _IO_2_1_stdout_;
extern struct _IO_FILE_plus _IO_2_1_stderr_;
typedef __ssize_t __io_read_fn (void *__cookie, char *__buf, size_t __nbytes);
typedef __ssize_t __io_write_fn (void *__cookie, __const char *__buf,
     size_t __n);
typedef int __io_seek_fn (void *__cookie, __off64_t *__pos, int __w);
typedef int __io_close_fn (void *__cookie);
extern int __underflow (_IO_FILE *) __attribute__ ((__nothrow__));
extern int __uflow (_IO_FILE *) __attribute__ ((__nothrow__));
extern int __overflow (_IO_FILE *, int) __attribute__ ((__nothrow__));
extern wint_t __wunderflow (_IO_FILE *) __attribute__ ((__nothrow__));
extern wint_t __wuflow (_IO_FILE *) __attribute__ ((__nothrow__));
extern wint_t __woverflow (_IO_FILE *, wint_t) __attribute__ ((__nothrow__));
extern int _IO_getc (_IO_FILE *__fp) __attribute__ ((__nothrow__));
extern int _IO_putc (int __c, _IO_FILE *__fp) __attribute__ ((__nothrow__));
extern int _IO_feof (_IO_FILE *__fp) __attribute__ ((__nothrow__));
extern int _IO_ferror (_IO_FILE *__fp) __attribute__ ((__nothrow__));
extern int _IO_peekc_locked (_IO_FILE *__fp) __attribute__ ((__nothrow__));
extern void _IO_flockfile (_IO_FILE *) __attribute__ ((__nothrow__));
extern void _IO_funlockfile (_IO_FILE *) __attribute__ ((__nothrow__));
extern int _IO_ftrylockfile (_IO_FILE *) __attribute__ ((__nothrow__));
extern int _IO_vfscanf (_IO_FILE * __restrict, const char * __restrict,
   __gnuc_va_list, int *__restrict) __attribute__ ((__nothrow__));
extern int _IO_vfprintf (_IO_FILE *__restrict, const char *__restrict,
    __gnuc_va_list) __attribute__ ((__nothrow__));
extern __ssize_t _IO_padn (_IO_FILE *, int, __ssize_t) __attribute__ ((__nothrow__));
extern size_t _IO_sgetn (_IO_FILE *, void *, size_t) __attribute__ ((__nothrow__));
extern __off64_t _IO_seekoff (_IO_FILE *, __off64_t, int, int) __attribute__ ((__nothrow__));
extern __off64_t _IO_seekpos (_IO_FILE *, __off64_t, int) __attribute__ ((__nothrow__));
extern void _IO_free_backup_area (_IO_FILE *) __attribute__ ((__nothrow__));

typedef _G_fpos_t fpos_t;

extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stdout;
extern struct _IO_FILE *stderr;

extern int remove (__const char *__filename) __attribute__ ((__nothrow__));
extern int rename (__const char *__old, __const char *__new) __attribute__ ((__nothrow__));


extern FILE *tmpfile (void);
extern char *tmpnam (char *__s) __attribute__ ((__nothrow__));

extern char *tmpnam_r (char *__s) __attribute__ ((__nothrow__));
extern char *tempnam (__const char *__dir, __const char *__pfx)
     __attribute__ ((__nothrow__)) __attribute__ ((__malloc__));

extern int fclose (FILE *__stream);
extern int fflush (FILE *__stream);

extern int fflush_unlocked (FILE *__stream);

extern FILE *fopen (__const char *__restrict __filename,
      __const char *__restrict __modes);
extern FILE *freopen (__const char *__restrict __filename,
        __const char *__restrict __modes,
        FILE *__restrict __stream);

extern FILE *fdopen (int __fd, __const char *__modes) __attribute__ ((__nothrow__));

extern void setbuf (FILE *__restrict __stream, char *__restrict __buf) __attribute__ ((__nothrow__));
extern int setvbuf (FILE *__restrict __stream, char *__restrict __buf,
      int __modes, size_t __n) __attribute__ ((__nothrow__));

extern void setbuffer (FILE *__restrict __stream, char *__restrict __buf,
         size_t __size) __attribute__ ((__nothrow__));
extern void setlinebuf (FILE *__stream) __attribute__ ((__nothrow__));

extern int fprintf (FILE *__restrict __stream,
      __const char *__restrict __format, ...);
extern int printf (__const char *__restrict __format, ...);
extern int sprintf (char *__restrict __s,
      __const char *__restrict __format, ...) __attribute__ ((__nothrow__));
extern int vfprintf (FILE *__restrict __s, __const char *__restrict __format,
       __gnuc_va_list __arg);
extern int vprintf (__const char *__restrict __format, __gnuc_va_list __arg);
extern int vsprintf (char *__restrict __s, __const char *__restrict __format,
       __gnuc_va_list __arg) __attribute__ ((__nothrow__));


extern int snprintf (char *__restrict __s, size_t __maxlen,
       __const char *__restrict __format, ...)
     __attribute__ ((__nothrow__)) __attribute__ ((__format__ (__printf__, 3, 4)));
extern int vsnprintf (char *__restrict __s, size_t __maxlen,
        __const char *__restrict __format, __gnuc_va_list __arg)
     __attribute__ ((__nothrow__)) __attribute__ ((__format__ (__printf__, 3, 0)));


extern int fscanf (FILE *__restrict __stream,
     __const char *__restrict __format, ...);
extern int scanf (__const char *__restrict __format, ...);
extern int sscanf (__const char *__restrict __s,
     __const char *__restrict __format, ...) __attribute__ ((__nothrow__));


extern int fgetc (FILE *__stream);
extern int getc (FILE *__stream);
extern int getchar (void);

extern int getc_unlocked (FILE *__stream);
extern int getchar_unlocked (void);
extern int fgetc_unlocked (FILE *__stream);

extern int fputc (int __c, FILE *__stream);
extern int putc (int __c, FILE *__stream);
extern int putchar (int __c);

extern int fputc_unlocked (int __c, FILE *__stream);
extern int putc_unlocked (int __c, FILE *__stream);
extern int putchar_unlocked (int __c);
extern int getw (FILE *__stream);
extern int putw (int __w, FILE *__stream);

extern char *fgets (char *__restrict __s, int __n, FILE *__restrict __stream);
extern char *gets (char *__s);


extern int fputs (__const char *__restrict __s, FILE *__restrict __stream);
extern int puts (__const char *__s);
extern int ungetc (int __c, FILE *__stream);
extern size_t fread (void *__restrict __ptr, size_t __size,
       size_t __n, FILE *__restrict __stream);
extern size_t fwrite (__const void *__restrict __ptr, size_t __size,
        size_t __n, FILE *__restrict __s);

extern size_t fread_unlocked (void *__restrict __ptr, size_t __size,
         size_t __n, FILE *__restrict __stream);
extern size_t fwrite_unlocked (__const void *__restrict __ptr, size_t __size,
          size_t __n, FILE *__restrict __stream);

extern int fseek (FILE *__stream, long int __off, int __whence);
extern long int ftell (FILE *__stream);
extern void rewind (FILE *__stream);


extern int fgetpos (FILE *__restrict __stream, fpos_t *__restrict __pos);
extern int fsetpos (FILE *__stream, __const fpos_t *__pos);


extern void clearerr (FILE *__stream) __attribute__ ((__nothrow__));
extern int feof (FILE *__stream) __attribute__ ((__nothrow__));
extern int ferror (FILE *__stream) __attribute__ ((__nothrow__));

extern void clearerr_unlocked (FILE *__stream) __attribute__ ((__nothrow__));
extern int feof_unlocked (FILE *__stream) __attribute__ ((__nothrow__));
extern int ferror_unlocked (FILE *__stream) __attribute__ ((__nothrow__));

extern void perror (__const char *__s);

extern int sys_nerr;
extern __const char *__const sys_errlist[];
extern int fileno (FILE *__stream) __attribute__ ((__nothrow__));
extern int fileno_unlocked (FILE *__stream) __attribute__ ((__nothrow__));
extern FILE *popen (__const char *__command, __const char *__modes);
extern int pclose (FILE *__stream);
extern char *ctermid (char *__s) __attribute__ ((__nothrow__));
extern void flockfile (FILE *__stream) __attribute__ ((__nothrow__));
extern int ftrylockfile (FILE *__stream) __attribute__ ((__nothrow__));
extern void funlockfile (FILE *__stream) __attribute__ ((__nothrow__));



extern double acos (double __x) __attribute__ ((__nothrow__)); extern double __acos (double __x) __attribute__ ((__nothrow__));
extern double asin (double __x) __attribute__ ((__nothrow__)); extern double __asin (double __x) __attribute__ ((__nothrow__));
extern double atan (double __x) __attribute__ ((__nothrow__)); extern double __atan (double __x) __attribute__ ((__nothrow__));
extern double atan2 (double __y, double __x) __attribute__ ((__nothrow__)); extern double __atan2 (double __y, double __x) __attribute__ ((__nothrow__));
extern double cos (double __x) __attribute__ ((__nothrow__)); extern double __cos (double __x) __attribute__ ((__nothrow__));
extern double sin (double __x) __attribute__ ((__nothrow__)); extern double __sin (double __x) __attribute__ ((__nothrow__));
extern double tan (double __x) __attribute__ ((__nothrow__)); extern double __tan (double __x) __attribute__ ((__nothrow__));
extern double cosh (double __x) __attribute__ ((__nothrow__)); extern double __cosh (double __x) __attribute__ ((__nothrow__));
extern double sinh (double __x) __attribute__ ((__nothrow__)); extern double __sinh (double __x) __attribute__ ((__nothrow__));
extern double tanh (double __x) __attribute__ ((__nothrow__)); extern double __tanh (double __x) __attribute__ ((__nothrow__));


extern double acosh (double __x) __attribute__ ((__nothrow__)); extern double __acosh (double __x) __attribute__ ((__nothrow__));
extern double asinh (double __x) __attribute__ ((__nothrow__)); extern double __asinh (double __x) __attribute__ ((__nothrow__));
extern double atanh (double __x) __attribute__ ((__nothrow__)); extern double __atanh (double __x) __attribute__ ((__nothrow__));


extern double exp (double __x) __attribute__ ((__nothrow__)); extern double __exp (double __x) __attribute__ ((__nothrow__));
extern double frexp (double __x, int *__exponent) __attribute__ ((__nothrow__)); extern double __frexp (double __x, int *__exponent) __attribute__ ((__nothrow__));
extern double ldexp (double __x, int __exponent) __attribute__ ((__nothrow__)); extern double __ldexp (double __x, int __exponent) __attribute__ ((__nothrow__));
extern double log (double __x) __attribute__ ((__nothrow__)); extern double __log (double __x) __attribute__ ((__nothrow__));
extern double log10 (double __x) __attribute__ ((__nothrow__)); extern double __log10 (double __x) __attribute__ ((__nothrow__));
extern double modf (double __x, double *__iptr) __attribute__ ((__nothrow__)); extern double __modf (double __x, double *__iptr) __attribute__ ((__nothrow__));


extern double expm1 (double __x) __attribute__ ((__nothrow__)); extern double __expm1 (double __x) __attribute__ ((__nothrow__));
extern double log1p (double __x) __attribute__ ((__nothrow__)); extern double __log1p (double __x) __attribute__ ((__nothrow__));
extern double logb (double __x) __attribute__ ((__nothrow__)); extern double __logb (double __x) __attribute__ ((__nothrow__));


extern double pow (double __x, double __y) __attribute__ ((__nothrow__)); extern double __pow (double __x, double __y) __attribute__ ((__nothrow__));
extern double sqrt (double __x) __attribute__ ((__nothrow__)); extern double __sqrt (double __x) __attribute__ ((__nothrow__));


extern double hypot (double __x, double __y) __attribute__ ((__nothrow__)); extern double __hypot (double __x, double __y) __attribute__ ((__nothrow__));


extern double cbrt (double __x) __attribute__ ((__nothrow__)); extern double __cbrt (double __x) __attribute__ ((__nothrow__));


extern double ceil (double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern double __ceil (double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern double fabs (double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern double __fabs (double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern double floor (double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern double __floor (double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern double fmod (double __x, double __y) __attribute__ ((__nothrow__)); extern double __fmod (double __x, double __y) __attribute__ ((__nothrow__));
extern int __isinf (double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int __finite (double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));

extern int isinf (double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int finite (double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern double drem (double __x, double __y) __attribute__ ((__nothrow__)); extern double __drem (double __x, double __y) __attribute__ ((__nothrow__));
extern double significand (double __x) __attribute__ ((__nothrow__)); extern double __significand (double __x) __attribute__ ((__nothrow__));

extern double copysign (double __x, double __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern double __copysign (double __x, double __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__));

extern int __isnan (double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int isnan (double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern double j0 (double) __attribute__ ((__nothrow__)); extern double __j0 (double) __attribute__ ((__nothrow__));
extern double j1 (double) __attribute__ ((__nothrow__)); extern double __j1 (double) __attribute__ ((__nothrow__));
extern double jn (int, double) __attribute__ ((__nothrow__)); extern double __jn (int, double) __attribute__ ((__nothrow__));
extern double y0 (double) __attribute__ ((__nothrow__)); extern double __y0 (double) __attribute__ ((__nothrow__));
extern double y1 (double) __attribute__ ((__nothrow__)); extern double __y1 (double) __attribute__ ((__nothrow__));
extern double yn (int, double) __attribute__ ((__nothrow__)); extern double __yn (int, double) __attribute__ ((__nothrow__));

extern double erf (double) __attribute__ ((__nothrow__)); extern double __erf (double) __attribute__ ((__nothrow__));
extern double erfc (double) __attribute__ ((__nothrow__)); extern double __erfc (double) __attribute__ ((__nothrow__));
extern double lgamma (double) __attribute__ ((__nothrow__)); extern double __lgamma (double) __attribute__ ((__nothrow__));

extern double gamma (double) __attribute__ ((__nothrow__)); extern double __gamma (double) __attribute__ ((__nothrow__));
extern double lgamma_r (double, int *__signgamp) __attribute__ ((__nothrow__)); extern double __lgamma_r (double, int *__signgamp) __attribute__ ((__nothrow__));

extern double rint (double __x) __attribute__ ((__nothrow__)); extern double __rint (double __x) __attribute__ ((__nothrow__));
extern double nextafter (double __x, double __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern double __nextafter (double __x, double __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern double remainder (double __x, double __y) __attribute__ ((__nothrow__)); extern double __remainder (double __x, double __y) __attribute__ ((__nothrow__));
extern double scalbn (double __x, int __n) __attribute__ ((__nothrow__)); extern double __scalbn (double __x, int __n) __attribute__ ((__nothrow__));
extern int ilogb (double __x) __attribute__ ((__nothrow__)); extern int __ilogb (double __x) __attribute__ ((__nothrow__));

extern float acosf (float __x) __attribute__ ((__nothrow__)); extern float __acosf (float __x) __attribute__ ((__nothrow__));
extern float asinf (float __x) __attribute__ ((__nothrow__)); extern float __asinf (float __x) __attribute__ ((__nothrow__));
extern float atanf (float __x) __attribute__ ((__nothrow__)); extern float __atanf (float __x) __attribute__ ((__nothrow__));
extern float atan2f (float __y, float __x) __attribute__ ((__nothrow__)); extern float __atan2f (float __y, float __x) __attribute__ ((__nothrow__));
extern float cosf (float __x) __attribute__ ((__nothrow__)); extern float __cosf (float __x) __attribute__ ((__nothrow__));
extern float sinf (float __x) __attribute__ ((__nothrow__)); extern float __sinf (float __x) __attribute__ ((__nothrow__));
extern float tanf (float __x) __attribute__ ((__nothrow__)); extern float __tanf (float __x) __attribute__ ((__nothrow__));
extern float coshf (float __x) __attribute__ ((__nothrow__)); extern float __coshf (float __x) __attribute__ ((__nothrow__));
extern float sinhf (float __x) __attribute__ ((__nothrow__)); extern float __sinhf (float __x) __attribute__ ((__nothrow__));
extern float tanhf (float __x) __attribute__ ((__nothrow__)); extern float __tanhf (float __x) __attribute__ ((__nothrow__));


extern float acoshf (float __x) __attribute__ ((__nothrow__)); extern float __acoshf (float __x) __attribute__ ((__nothrow__));
extern float asinhf (float __x) __attribute__ ((__nothrow__)); extern float __asinhf (float __x) __attribute__ ((__nothrow__));
extern float atanhf (float __x) __attribute__ ((__nothrow__)); extern float __atanhf (float __x) __attribute__ ((__nothrow__));


extern float expf (float __x) __attribute__ ((__nothrow__)); extern float __expf (float __x) __attribute__ ((__nothrow__));
extern float frexpf (float __x, int *__exponent) __attribute__ ((__nothrow__)); extern float __frexpf (float __x, int *__exponent) __attribute__ ((__nothrow__));
extern float ldexpf (float __x, int __exponent) __attribute__ ((__nothrow__)); extern float __ldexpf (float __x, int __exponent) __attribute__ ((__nothrow__));
extern float logf (float __x) __attribute__ ((__nothrow__)); extern float __logf (float __x) __attribute__ ((__nothrow__));
extern float log10f (float __x) __attribute__ ((__nothrow__)); extern float __log10f (float __x) __attribute__ ((__nothrow__));
extern float modff (float __x, float *__iptr) __attribute__ ((__nothrow__)); extern float __modff (float __x, float *__iptr) __attribute__ ((__nothrow__));


extern float expm1f (float __x) __attribute__ ((__nothrow__)); extern float __expm1f (float __x) __attribute__ ((__nothrow__));
extern float log1pf (float __x) __attribute__ ((__nothrow__)); extern float __log1pf (float __x) __attribute__ ((__nothrow__));
extern float logbf (float __x) __attribute__ ((__nothrow__)); extern float __logbf (float __x) __attribute__ ((__nothrow__));


extern float powf (float __x, float __y) __attribute__ ((__nothrow__)); extern float __powf (float __x, float __y) __attribute__ ((__nothrow__));
extern float sqrtf (float __x) __attribute__ ((__nothrow__)); extern float __sqrtf (float __x) __attribute__ ((__nothrow__));


extern float hypotf (float __x, float __y) __attribute__ ((__nothrow__)); extern float __hypotf (float __x, float __y) __attribute__ ((__nothrow__));


extern float cbrtf (float __x) __attribute__ ((__nothrow__)); extern float __cbrtf (float __x) __attribute__ ((__nothrow__));


extern float ceilf (float __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern float __ceilf (float __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern float fabsf (float __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern float __fabsf (float __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern float floorf (float __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern float __floorf (float __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern float fmodf (float __x, float __y) __attribute__ ((__nothrow__)); extern float __fmodf (float __x, float __y) __attribute__ ((__nothrow__));
extern int __isinff (float __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int __finitef (float __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));

extern int isinff (float __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int finitef (float __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern float dremf (float __x, float __y) __attribute__ ((__nothrow__)); extern float __dremf (float __x, float __y) __attribute__ ((__nothrow__));
extern float significandf (float __x) __attribute__ ((__nothrow__)); extern float __significandf (float __x) __attribute__ ((__nothrow__));

extern float copysignf (float __x, float __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern float __copysignf (float __x, float __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__));

extern int __isnanf (float __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int isnanf (float __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern float j0f (float) __attribute__ ((__nothrow__)); extern float __j0f (float) __attribute__ ((__nothrow__));
extern float j1f (float) __attribute__ ((__nothrow__)); extern float __j1f (float) __attribute__ ((__nothrow__));
extern float jnf (int, float) __attribute__ ((__nothrow__)); extern float __jnf (int, float) __attribute__ ((__nothrow__));
extern float y0f (float) __attribute__ ((__nothrow__)); extern float __y0f (float) __attribute__ ((__nothrow__));
extern float y1f (float) __attribute__ ((__nothrow__)); extern float __y1f (float) __attribute__ ((__nothrow__));
extern float ynf (int, float) __attribute__ ((__nothrow__)); extern float __ynf (int, float) __attribute__ ((__nothrow__));

extern float erff (float) __attribute__ ((__nothrow__)); extern float __erff (float) __attribute__ ((__nothrow__));
extern float erfcf (float) __attribute__ ((__nothrow__)); extern float __erfcf (float) __attribute__ ((__nothrow__));
extern float lgammaf (float) __attribute__ ((__nothrow__)); extern float __lgammaf (float) __attribute__ ((__nothrow__));

extern float gammaf (float) __attribute__ ((__nothrow__)); extern float __gammaf (float) __attribute__ ((__nothrow__));
extern float lgammaf_r (float, int *__signgamp) __attribute__ ((__nothrow__)); extern float __lgammaf_r (float, int *__signgamp) __attribute__ ((__nothrow__));

extern float rintf (float __x) __attribute__ ((__nothrow__)); extern float __rintf (float __x) __attribute__ ((__nothrow__));
extern float nextafterf (float __x, float __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern float __nextafterf (float __x, float __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern float remainderf (float __x, float __y) __attribute__ ((__nothrow__)); extern float __remainderf (float __x, float __y) __attribute__ ((__nothrow__));
extern float scalbnf (float __x, int __n) __attribute__ ((__nothrow__)); extern float __scalbnf (float __x, int __n) __attribute__ ((__nothrow__));
extern int ilogbf (float __x) __attribute__ ((__nothrow__)); extern int __ilogbf (float __x) __attribute__ ((__nothrow__));

extern long double acosl (long double __x) __attribute__ ((__nothrow__)); extern long double __acosl (long double __x) __attribute__ ((__nothrow__));
extern long double asinl (long double __x) __attribute__ ((__nothrow__)); extern long double __asinl (long double __x) __attribute__ ((__nothrow__));
extern long double atanl (long double __x) __attribute__ ((__nothrow__)); extern long double __atanl (long double __x) __attribute__ ((__nothrow__));
extern long double atan2l (long double __y, long double __x) __attribute__ ((__nothrow__)); extern long double __atan2l (long double __y, long double __x) __attribute__ ((__nothrow__));
extern long double cosl (long double __x) __attribute__ ((__nothrow__)); extern long double __cosl (long double __x) __attribute__ ((__nothrow__));
extern long double sinl (long double __x) __attribute__ ((__nothrow__)); extern long double __sinl (long double __x) __attribute__ ((__nothrow__));
extern long double tanl (long double __x) __attribute__ ((__nothrow__)); extern long double __tanl (long double __x) __attribute__ ((__nothrow__));
extern long double coshl (long double __x) __attribute__ ((__nothrow__)); extern long double __coshl (long double __x) __attribute__ ((__nothrow__));
extern long double sinhl (long double __x) __attribute__ ((__nothrow__)); extern long double __sinhl (long double __x) __attribute__ ((__nothrow__));
extern long double tanhl (long double __x) __attribute__ ((__nothrow__)); extern long double __tanhl (long double __x) __attribute__ ((__nothrow__));


extern long double acoshl (long double __x) __attribute__ ((__nothrow__)); extern long double __acoshl (long double __x) __attribute__ ((__nothrow__));
extern long double asinhl (long double __x) __attribute__ ((__nothrow__)); extern long double __asinhl (long double __x) __attribute__ ((__nothrow__));
extern long double atanhl (long double __x) __attribute__ ((__nothrow__)); extern long double __atanhl (long double __x) __attribute__ ((__nothrow__));


extern long double expl (long double __x) __attribute__ ((__nothrow__)); extern long double __expl (long double __x) __attribute__ ((__nothrow__));
extern long double frexpl (long double __x, int *__exponent) __attribute__ ((__nothrow__)); extern long double __frexpl (long double __x, int *__exponent) __attribute__ ((__nothrow__));
extern long double ldexpl (long double __x, int __exponent) __attribute__ ((__nothrow__)); extern long double __ldexpl (long double __x, int __exponent) __attribute__ ((__nothrow__));
extern long double logl (long double __x) __attribute__ ((__nothrow__)); extern long double __logl (long double __x) __attribute__ ((__nothrow__));
extern long double log10l (long double __x) __attribute__ ((__nothrow__)); extern long double __log10l (long double __x) __attribute__ ((__nothrow__));
extern long double modfl (long double __x, long double *__iptr) __attribute__ ((__nothrow__)); extern long double __modfl (long double __x, long double *__iptr) __attribute__ ((__nothrow__));


extern long double expm1l (long double __x) __attribute__ ((__nothrow__)); extern long double __expm1l (long double __x) __attribute__ ((__nothrow__));
extern long double log1pl (long double __x) __attribute__ ((__nothrow__)); extern long double __log1pl (long double __x) __attribute__ ((__nothrow__));
extern long double logbl (long double __x) __attribute__ ((__nothrow__)); extern long double __logbl (long double __x) __attribute__ ((__nothrow__));


extern long double powl (long double __x, long double __y) __attribute__ ((__nothrow__)); extern long double __powl (long double __x, long double __y) __attribute__ ((__nothrow__));
extern long double sqrtl (long double __x) __attribute__ ((__nothrow__)); extern long double __sqrtl (long double __x) __attribute__ ((__nothrow__));


extern long double hypotl (long double __x, long double __y) __attribute__ ((__nothrow__)); extern long double __hypotl (long double __x, long double __y) __attribute__ ((__nothrow__));


extern long double cbrtl (long double __x) __attribute__ ((__nothrow__)); extern long double __cbrtl (long double __x) __attribute__ ((__nothrow__));


extern long double ceill (long double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern long double __ceill (long double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern long double fabsl (long double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern long double __fabsl (long double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern long double floorl (long double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern long double __floorl (long double __x) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern long double fmodl (long double __x, long double __y) __attribute__ ((__nothrow__)); extern long double __fmodl (long double __x, long double __y) __attribute__ ((__nothrow__));
extern int __isinfl (long double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int __finitel (long double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));

extern int isinfl (long double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int finitel (long double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern long double dreml (long double __x, long double __y) __attribute__ ((__nothrow__)); extern long double __dreml (long double __x, long double __y) __attribute__ ((__nothrow__));
extern long double significandl (long double __x) __attribute__ ((__nothrow__)); extern long double __significandl (long double __x) __attribute__ ((__nothrow__));

extern long double copysignl (long double __x, long double __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern long double __copysignl (long double __x, long double __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__));

extern int __isnanl (long double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int isnanl (long double __value) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern long double j0l (long double) __attribute__ ((__nothrow__)); extern long double __j0l (long double) __attribute__ ((__nothrow__));
extern long double j1l (long double) __attribute__ ((__nothrow__)); extern long double __j1l (long double) __attribute__ ((__nothrow__));
extern long double jnl (int, long double) __attribute__ ((__nothrow__)); extern long double __jnl (int, long double) __attribute__ ((__nothrow__));
extern long double y0l (long double) __attribute__ ((__nothrow__)); extern long double __y0l (long double) __attribute__ ((__nothrow__));
extern long double y1l (long double) __attribute__ ((__nothrow__)); extern long double __y1l (long double) __attribute__ ((__nothrow__));
extern long double ynl (int, long double) __attribute__ ((__nothrow__)); extern long double __ynl (int, long double) __attribute__ ((__nothrow__));

extern long double erfl (long double) __attribute__ ((__nothrow__)); extern long double __erfl (long double) __attribute__ ((__nothrow__));
extern long double erfcl (long double) __attribute__ ((__nothrow__)); extern long double __erfcl (long double) __attribute__ ((__nothrow__));
extern long double lgammal (long double) __attribute__ ((__nothrow__)); extern long double __lgammal (long double) __attribute__ ((__nothrow__));

extern long double gammal (long double) __attribute__ ((__nothrow__)); extern long double __gammal (long double) __attribute__ ((__nothrow__));
extern long double lgammal_r (long double, int *__signgamp) __attribute__ ((__nothrow__)); extern long double __lgammal_r (long double, int *__signgamp) __attribute__ ((__nothrow__));

extern long double rintl (long double __x) __attribute__ ((__nothrow__)); extern long double __rintl (long double __x) __attribute__ ((__nothrow__));
extern long double nextafterl (long double __x, long double __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__)); extern long double __nextafterl (long double __x, long double __y) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern long double remainderl (long double __x, long double __y) __attribute__ ((__nothrow__)); extern long double __remainderl (long double __x, long double __y) __attribute__ ((__nothrow__));
extern long double scalbnl (long double __x, int __n) __attribute__ ((__nothrow__)); extern long double __scalbnl (long double __x, int __n) __attribute__ ((__nothrow__));
extern int ilogbl (long double __x) __attribute__ ((__nothrow__)); extern int __ilogbl (long double __x) __attribute__ ((__nothrow__));
extern int signgam;
typedef enum
{
  _IEEE_ = -1,
  _SVID_,
  _XOPEN_,
  _POSIX_,
  _ISOC_
} _LIB_VERSION_TYPE;
extern _LIB_VERSION_TYPE _LIB_VERSION;
struct exception
  {
    int type;
    char *name;
    double arg1;
    double arg2;
    double retval;
  };
extern int matherr (struct exception *__exc);

typedef struct
{
   double re,im;
} complex;
typedef struct
{
   float re,im;
} complex32;
typedef struct
{
   complex c00,c01,c02,c10,c11,c12,c20,c21,c22;
} su3;
typedef struct
{
   complex c0,c1,c2;
} su3_vector;
typedef struct
{
    complex32 c0,c1,c2;
} su3_vector32;
typedef struct
{
   su3_vector s0,s1,s2,s3;
} spinor;
typedef struct
{
  su3_vector s0, s1;
} halfspinor;
typedef struct
{
   su3_vector32 s0, s1;
} halfspinor32;
typedef struct
{
   spinor sp_up,sp_dn;
} bispinor;

extern long int __sysconf (int);

typedef __clock_t clock_t;



struct tm
{
  int tm_sec;
  int tm_min;
  int tm_hour;
  int tm_mday;
  int tm_mon;
  int tm_year;
  int tm_wday;
  int tm_yday;
  int tm_isdst;
  long int tm_gmtoff;
  __const char *tm_zone;
};


struct itimerspec
  {
    struct timespec it_interval;
    struct timespec it_value;
  };
struct sigevent;

extern clock_t clock (void) __attribute__ ((__nothrow__));
extern time_t time (time_t *__timer) __attribute__ ((__nothrow__));
extern double difftime (time_t __time1, time_t __time0)
     __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern time_t mktime (struct tm *__tp) __attribute__ ((__nothrow__));
extern size_t strftime (char *__restrict __s, size_t __maxsize,
   __const char *__restrict __format,
   __const struct tm *__restrict __tp) __attribute__ ((__nothrow__));


extern struct tm *gmtime (__const time_t *__timer) __attribute__ ((__nothrow__));
extern struct tm *localtime (__const time_t *__timer) __attribute__ ((__nothrow__));

extern struct tm *gmtime_r (__const time_t *__restrict __timer,
       struct tm *__restrict __tp) __attribute__ ((__nothrow__));
extern struct tm *localtime_r (__const time_t *__restrict __timer,
          struct tm *__restrict __tp) __attribute__ ((__nothrow__));

extern char *asctime (__const struct tm *__tp) __attribute__ ((__nothrow__));
extern char *ctime (__const time_t *__timer) __attribute__ ((__nothrow__));

extern char *asctime_r (__const struct tm *__restrict __tp,
   char *__restrict __buf) __attribute__ ((__nothrow__));
extern char *ctime_r (__const time_t *__restrict __timer,
        char *__restrict __buf) __attribute__ ((__nothrow__));
extern char *__tzname[2];
extern int __daylight;
extern long int __timezone;
extern char *tzname[2];
extern void tzset (void) __attribute__ ((__nothrow__));
extern int daylight;
extern long int timezone;
extern int stime (__const time_t *__when) __attribute__ ((__nothrow__));
extern time_t timegm (struct tm *__tp) __attribute__ ((__nothrow__));
extern time_t timelocal (struct tm *__tp) __attribute__ ((__nothrow__));
extern int dysize (int __year) __attribute__ ((__nothrow__)) __attribute__ ((__const__));
extern int nanosleep (__const struct timespec *__requested_time,
        struct timespec *__remaining);
extern int clock_getres (clockid_t __clock_id, struct timespec *__res) __attribute__ ((__nothrow__));
extern int clock_gettime (clockid_t __clock_id, struct timespec *__tp) __attribute__ ((__nothrow__));
extern int clock_settime (clockid_t __clock_id, __const struct timespec *__tp)
     __attribute__ ((__nothrow__));
extern int timer_create (clockid_t __clock_id,
    struct sigevent *__restrict __evp,
    timer_t *__restrict __timerid) __attribute__ ((__nothrow__));
extern int timer_delete (timer_t __timerid) __attribute__ ((__nothrow__));
extern int timer_settime (timer_t __timerid, int __flags,
     __const struct itimerspec *__restrict __value,
     struct itimerspec *__restrict __ovalue) __attribute__ ((__nothrow__));
extern int timer_gettime (timer_t __timerid, struct itimerspec *__value)
     __attribute__ ((__nothrow__));
extern int timer_getoverrun (timer_t __timerid) __attribute__ ((__nothrow__));

int HM_cpt;
su3 ** g_gauge_field_copy;
su3 ** g_gauge_field_copy2;
halfspinor ***NBPointer;
spinor *l, *k;
complex ka0, ka1, ka2, ka3;
time_t global;
void Hopping_Matrix(const int ieo, spinor * const l, spinor * const k);
int HM_cpt;
su3 ** g_gauge_field_copy;
su3 ** g_gauge_field_copy2;
halfspinor ***NBPointer;
spinor *l, *k;
complex ka0, ka1, ka2, ka3;
time_t global;
void Hopping_Matrix(const int ieo, spinor * const l, spinor * const k){
   int i,ix, j, z;
   su3 * restrict iU ;
   spinor * restrict s ;
   su3_vector psi, chi;
   halfspinor * restrict * phi ;
   time_t current;
   su3 * restrict save_iU ;
   spinor * restrict save_s ;
   int save_ix;
   if(HM_cpt>2450432){
      printf("ERREUR! je suis passe dans la fonction plus de %d fois!!!!\n", 2450432);
      exit(-1);
   }
   if(k == l){
      printf("Error in H_psi (simple.c):\n");
      printf("Arguments k and l must be different\n");
      printf("Program aborted\n");
      exit(1);
   }
   s = k;
    current=time((time_t *)0);
    HM_cpt++;
#pragma omp parallel num_threads(NBT)
{
#pragma omp for private(j,phi,iU)
   for(j=0; j<(131072)/2; j+=128){
     s = k;
     if(ieo == 0) {
       iU = g_gauge_field_copy2[0];
     }
     else {
       iU = g_gauge_field_copy2[0]+131072/2;
     }
    s+=j;
    iU+=j;
    phi = NBPointer[ieo];
    save_s = s;
    save_iU = iU;
    ix=j*2;
#pragma xlang begin
    for(i = 0; i < 128; i++){
      ((*phi[ix+i*2]).s0).c0.re=(ka0).re*(chi).c0.re-(ka0).im*(chi).c0.im; ((*phi[ix+i*2]).s0).c0.im=(ka0).re*(chi).c0.im+(ka0).im*(chi).c0.re; ((*phi[ix+i*2]).s0).c1.re=(ka0).re*(chi).c1.re-(ka0).im*(chi).c1.im; ((*phi[ix+i*2]).s0).c1.im=(ka0).re*(chi).c1.im+(ka0).im*(chi).c1.re; ((*phi[ix+i*2]).s0).c2.re=(ka0).re*(chi).c2.re-(ka0).im*(chi).c2.im; ((*phi[ix+i*2]).s0).c2.im=(ka0).re*(chi).c2.im+(ka0).im*(chi).c2.re;;
      iU=iU+1;
      ((*phi[ix+1+i*2]).s0).c0.re=((*s).s0).c0.re-((*s).s2).c0.re; ((*phi[ix+1+i*2]).s0).c0.im=((*s).s0).c0.im-((*s).s2).c0.im; ((*phi[ix+1+i*2]).s0).c1.re=((*s).s0).c1.re-((*s).s2).c1.re; ((*phi[ix+1+i*2]).s0).c1.im=((*s).s0).c1.im-((*s).s2).c1.im; ((*phi[ix+1+i*2]).s0).c2.re=((*s).s0).c2.re-((*s).s2).c2.re; ((*phi[ix+1+i*2]).s0).c2.im=((*s).s0).c2.im-((*s).s2).c2.im;;
      s=s+1;
    }
#pragma xlang parameter Ui [1,2]
#pragma xlang transform unroll(i,Ui)
#pragma xlang end
    s = save_s;
    iU = save_iU;
    for(i = 0; i < 128; i++){
      (psi).c0.re=((*s).s1).c0.re+((*s).s3).c0.re; (psi).c0.im=((*s).s1).c0.im+((*s).s3).c0.im; (psi).c1.re=((*s).s1).c1.re+((*s).s3).c1.re; (psi).c1.im=((*s).s1).c1.im+((*s).s3).c1.im; (psi).c2.re=((*s).s1).c2.re+((*s).s3).c2.re; (psi).c2.im=((*s).s1).c2.im+((*s).s3).c2.im;;
      (chi).c0.re= ((*iU)).c00.re*(psi).c0.re-((*iU)).c00.im*(psi).c0.im +((*iU)).c01.re*(psi).c1.re-((*iU)).c01.im*(psi).c1.im +((*iU)).c02.re*(psi).c2.re-((*iU)).c02.im*(psi).c2.im; (chi).c0.im= ((*iU)).c00.re*(psi).c0.im+((*iU)).c00.im*(psi).c0.re +((*iU)).c01.re*(psi).c1.im+((*iU)).c01.im*(psi).c1.re +((*iU)).c02.re*(psi).c2.im+((*iU)).c02.im*(psi).c2.re; (chi).c1.re= ((*iU)).c10.re*(psi).c0.re-((*iU)).c10.im*(psi).c0.im +((*iU)).c11.re*(psi).c1.re-((*iU)).c11.im*(psi).c1.im +((*iU)).c12.re*(psi).c2.re-((*iU)).c12.im*(psi).c2.im; (chi).c1.im= ((*iU)).c10.re*(psi).c0.im+((*iU)).c10.im*(psi).c0.re +((*iU)).c11.re*(psi).c1.im+((*iU)).c11.im*(psi).c1.re +((*iU)).c12.re*(psi).c2.im+((*iU)).c12.im*(psi).c2.re; (chi).c2.re= ((*iU)).c20.re*(psi).c0.re-((*iU)).c20.im*(psi).c0.im +((*iU)).c21.re*(psi).c1.re-((*iU)).c21.im*(psi).c1.im +((*iU)).c22.re*(psi).c2.re-((*iU)).c22.im*(psi).c2.im; (chi).c2.im= ((*iU)).c20.re*(psi).c0.im+((*iU)).c20.im*(psi).c0.re +((*iU)).c21.re*(psi).c1.im+((*iU)).c21.im*(psi).c1.re +((*iU)).c22.re*(psi).c2.im+((*iU)).c22.im*(psi).c2.re;;
      ((*phi[ix+i*2]).s1).c0.re=(ka0).re*(chi).c0.re-(ka0).im*(chi).c0.im; ((*phi[ix+i*2]).s1).c0.im=(ka0).re*(chi).c0.im+(ka0).im*(chi).c0.re; ((*phi[ix+i*2]).s1).c1.re=(ka0).re*(chi).c1.re-(ka0).im*(chi).c1.im; ((*phi[ix+i*2]).s1).c1.im=(ka0).re*(chi).c1.im+(ka0).im*(chi).c1.re; ((*phi[ix+i*2]).s1).c2.re=(ka0).re*(chi).c2.re-(ka0).im*(chi).c2.im; ((*phi[ix+i*2]).s1).c2.im=(ka0).re*(chi).c2.im+(ka0).im*(chi).c2.re;;
      iU++;
      ((*phi[ix+1+i*2]).s1).c0.re=((*s).s1).c0.re-((*s).s3).c0.re; ((*phi[ix+1+i*2]).s1).c0.im=((*s).s1).c0.im-((*s).s3).c0.im; ((*phi[ix+1+i*2]).s1).c1.re=((*s).s1).c1.re-((*s).s3).c1.re; ((*phi[ix+1+i*2]).s1).c1.im=((*s).s1).c1.im-((*s).s3).c1.im; ((*phi[ix+1+i*2]).s1).c2.re=((*s).s1).c2.re-((*s).s3).c2.re; ((*phi[ix+1+i*2]).s1).c2.im=((*s).s1).c2.im-((*s).s3).c2.im;;
      s++;
    }
    ix+=131072;
    s=k;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[1];
    }
    else {
      iU = g_gauge_field_copy2[1]+131072/2;
    }
    s+=j;
    iU+=j;
    save_s = s;
    save_iU = iU;
    for(i = 0; i < 128; i++){
      (psi).c0.re=((*s).s0).c0.re-((*s).s3).c0.im; (psi).c0.im=((*s).s0).c0.im+((*s).s3).c0.re; (psi).c1.re=((*s).s0).c1.re-((*s).s3).c1.im; (psi).c1.im=((*s).s0).c1.im+((*s).s3).c1.re; (psi).c2.re=((*s).s0).c2.re-((*s).s3).c2.im; (psi).c2.im=((*s).s0).c2.im+((*s).s3).c2.re;;
      (chi).c0.re= ((*iU)).c00.re*(psi).c0.re-((*iU)).c00.im*(psi).c0.im +((*iU)).c01.re*(psi).c1.re-((*iU)).c01.im*(psi).c1.im +((*iU)).c02.re*(psi).c2.re-((*iU)).c02.im*(psi).c2.im; (chi).c0.im= ((*iU)).c00.re*(psi).c0.im+((*iU)).c00.im*(psi).c0.re +((*iU)).c01.re*(psi).c1.im+((*iU)).c01.im*(psi).c1.re +((*iU)).c02.re*(psi).c2.im+((*iU)).c02.im*(psi).c2.re; (chi).c1.re= ((*iU)).c10.re*(psi).c0.re-((*iU)).c10.im*(psi).c0.im +((*iU)).c11.re*(psi).c1.re-((*iU)).c11.im*(psi).c1.im +((*iU)).c12.re*(psi).c2.re-((*iU)).c12.im*(psi).c2.im; (chi).c1.im= ((*iU)).c10.re*(psi).c0.im+((*iU)).c10.im*(psi).c0.re +((*iU)).c11.re*(psi).c1.im+((*iU)).c11.im*(psi).c1.re +((*iU)).c12.re*(psi).c2.im+((*iU)).c12.im*(psi).c2.re; (chi).c2.re= ((*iU)).c20.re*(psi).c0.re-((*iU)).c20.im*(psi).c0.im +((*iU)).c21.re*(psi).c1.re-((*iU)).c21.im*(psi).c1.im +((*iU)).c22.re*(psi).c2.re-((*iU)).c22.im*(psi).c2.im; (chi).c2.im= ((*iU)).c20.re*(psi).c0.im+((*iU)).c20.im*(psi).c0.re +((*iU)).c21.re*(psi).c1.im+((*iU)).c21.im*(psi).c1.re +((*iU)).c22.re*(psi).c2.im+((*iU)).c22.im*(psi).c2.re;;
      ((*phi[ix+i*2]).s0).c0.re=(ka1).re*(chi).c0.re-(ka1).im*(chi).c0.im; ((*phi[ix+i*2]).s0).c0.im=(ka1).re*(chi).c0.im+(ka1).im*(chi).c0.re; ((*phi[ix+i*2]).s0).c1.re=(ka1).re*(chi).c1.re-(ka1).im*(chi).c1.im; ((*phi[ix+i*2]).s0).c1.im=(ka1).re*(chi).c1.im+(ka1).im*(chi).c1.re; ((*phi[ix+i*2]).s0).c2.re=(ka1).re*(chi).c2.re-(ka1).im*(chi).c2.im; ((*phi[ix+i*2]).s0).c2.im=(ka1).re*(chi).c2.im+(ka1).im*(chi).c2.re;;
      iU++;
      ((*phi[ix+1+i*2]).s0).c0.re=((*s).s0).c0.re+((*s).s3).c0.im; ((*phi[ix+1+i*2]).s0).c0.im=((*s).s0).c0.im-((*s).s3).c0.re; ((*phi[ix+1+i*2]).s0).c1.re=((*s).s0).c1.re+((*s).s3).c1.im; ((*phi[ix+1+i*2]).s0).c1.im=((*s).s0).c1.im-((*s).s3).c1.re; ((*phi[ix+1+i*2]).s0).c2.re=((*s).s0).c2.re+((*s).s3).c2.im; ((*phi[ix+1+i*2]).s0).c2.im=((*s).s0).c2.im-((*s).s3).c2.re;;
      s++;
    }
    s = save_s;
    iU = save_iU;
    for(i = 0; i < 128; i++){
      (psi).c0.re=((*s).s1).c0.re-((*s).s2).c0.im; (psi).c0.im=((*s).s1).c0.im+((*s).s2).c0.re; (psi).c1.re=((*s).s1).c1.re-((*s).s2).c1.im; (psi).c1.im=((*s).s1).c1.im+((*s).s2).c1.re; (psi).c2.re=((*s).s1).c2.re-((*s).s2).c2.im; (psi).c2.im=((*s).s1).c2.im+((*s).s2).c2.re;;
      (chi).c0.re= ((*iU)).c00.re*(psi).c0.re-((*iU)).c00.im*(psi).c0.im +((*iU)).c01.re*(psi).c1.re-((*iU)).c01.im*(psi).c1.im +((*iU)).c02.re*(psi).c2.re-((*iU)).c02.im*(psi).c2.im; (chi).c0.im= ((*iU)).c00.re*(psi).c0.im+((*iU)).c00.im*(psi).c0.re +((*iU)).c01.re*(psi).c1.im+((*iU)).c01.im*(psi).c1.re +((*iU)).c02.re*(psi).c2.im+((*iU)).c02.im*(psi).c2.re; (chi).c1.re= ((*iU)).c10.re*(psi).c0.re-((*iU)).c10.im*(psi).c0.im +((*iU)).c11.re*(psi).c1.re-((*iU)).c11.im*(psi).c1.im +((*iU)).c12.re*(psi).c2.re-((*iU)).c12.im*(psi).c2.im; (chi).c1.im= ((*iU)).c10.re*(psi).c0.im+((*iU)).c10.im*(psi).c0.re +((*iU)).c11.re*(psi).c1.im+((*iU)).c11.im*(psi).c1.re +((*iU)).c12.re*(psi).c2.im+((*iU)).c12.im*(psi).c2.re; (chi).c2.re= ((*iU)).c20.re*(psi).c0.re-((*iU)).c20.im*(psi).c0.im +((*iU)).c21.re*(psi).c1.re-((*iU)).c21.im*(psi).c1.im +((*iU)).c22.re*(psi).c2.re-((*iU)).c22.im*(psi).c2.im; (chi).c2.im= ((*iU)).c20.re*(psi).c0.im+((*iU)).c20.im*(psi).c0.re +((*iU)).c21.re*(psi).c1.im+((*iU)).c21.im*(psi).c1.re +((*iU)).c22.re*(psi).c2.im+((*iU)).c22.im*(psi).c2.re;;
      ((*phi[ix+i*2]).s1).c0.re=(ka1).re*(chi).c0.re-(ka1).im*(chi).c0.im; ((*phi[ix+i*2]).s1).c0.im=(ka1).re*(chi).c0.im+(ka1).im*(chi).c0.re; ((*phi[ix+i*2]).s1).c1.re=(ka1).re*(chi).c1.re-(ka1).im*(chi).c1.im; ((*phi[ix+i*2]).s1).c1.im=(ka1).re*(chi).c1.im+(ka1).im*(chi).c1.re; ((*phi[ix+i*2]).s1).c2.re=(ka1).re*(chi).c2.re-(ka1).im*(chi).c2.im; ((*phi[ix+i*2]).s1).c2.im=(ka1).re*(chi).c2.im+(ka1).im*(chi).c2.re;;
       iU++;
      ((*phi[ix+1+i*2]).s1).c0.re=((*s).s1).c0.re+((*s).s2).c0.im; ((*phi[ix+1+i*2]).s1).c0.im=((*s).s1).c0.im-((*s).s2).c0.re; ((*phi[ix+1+i*2]).s1).c1.re=((*s).s1).c1.re+((*s).s2).c1.im; ((*phi[ix+1+i*2]).s1).c1.im=((*s).s1).c1.im-((*s).s2).c1.re; ((*phi[ix+1+i*2]).s1).c2.re=((*s).s1).c2.re+((*s).s2).c2.im; ((*phi[ix+1+i*2]).s1).c2.im=((*s).s1).c2.im-((*s).s2).c2.re;;
      s++;
    }
    ix+=131072;
    s=k;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[2];
    }
    else {
      iU = g_gauge_field_copy2[2]+131072/2;
    }
    s+=j;
    iU+=j;
    save_s = s;
    save_iU = iU;
    for(i = 0; i < 128; i++){
      (psi).c0.re=((*s).s0).c0.re+((*s).s3).c0.re; (psi).c0.im=((*s).s0).c0.im+((*s).s3).c0.im; (psi).c1.re=((*s).s0).c1.re+((*s).s3).c1.re; (psi).c1.im=((*s).s0).c1.im+((*s).s3).c1.im; (psi).c2.re=((*s).s0).c2.re+((*s).s3).c2.re; (psi).c2.im=((*s).s0).c2.im+((*s).s3).c2.im;;
      (chi).c0.re= ((*iU)).c00.re*(psi).c0.re-((*iU)).c00.im*(psi).c0.im +((*iU)).c01.re*(psi).c1.re-((*iU)).c01.im*(psi).c1.im +((*iU)).c02.re*(psi).c2.re-((*iU)).c02.im*(psi).c2.im; (chi).c0.im= ((*iU)).c00.re*(psi).c0.im+((*iU)).c00.im*(psi).c0.re +((*iU)).c01.re*(psi).c1.im+((*iU)).c01.im*(psi).c1.re +((*iU)).c02.re*(psi).c2.im+((*iU)).c02.im*(psi).c2.re; (chi).c1.re= ((*iU)).c10.re*(psi).c0.re-((*iU)).c10.im*(psi).c0.im +((*iU)).c11.re*(psi).c1.re-((*iU)).c11.im*(psi).c1.im +((*iU)).c12.re*(psi).c2.re-((*iU)).c12.im*(psi).c2.im; (chi).c1.im= ((*iU)).c10.re*(psi).c0.im+((*iU)).c10.im*(psi).c0.re +((*iU)).c11.re*(psi).c1.im+((*iU)).c11.im*(psi).c1.re +((*iU)).c12.re*(psi).c2.im+((*iU)).c12.im*(psi).c2.re; (chi).c2.re= ((*iU)).c20.re*(psi).c0.re-((*iU)).c20.im*(psi).c0.im +((*iU)).c21.re*(psi).c1.re-((*iU)).c21.im*(psi).c1.im +((*iU)).c22.re*(psi).c2.re-((*iU)).c22.im*(psi).c2.im; (chi).c2.im= ((*iU)).c20.re*(psi).c0.im+((*iU)).c20.im*(psi).c0.re +((*iU)).c21.re*(psi).c1.im+((*iU)).c21.im*(psi).c1.re +((*iU)).c22.re*(psi).c2.im+((*iU)).c22.im*(psi).c2.re;;
      ((*phi[ix+i*2]).s0).c0.re=(ka2).re*(chi).c0.re-(ka2).im*(chi).c0.im; ((*phi[ix+i*2]).s0).c0.im=(ka2).re*(chi).c0.im+(ka2).im*(chi).c0.re; ((*phi[ix+i*2]).s0).c1.re=(ka2).re*(chi).c1.re-(ka2).im*(chi).c1.im; ((*phi[ix+i*2]).s0).c1.im=(ka2).re*(chi).c1.im+(ka2).im*(chi).c1.re; ((*phi[ix+i*2]).s0).c2.re=(ka2).re*(chi).c2.re-(ka2).im*(chi).c2.im; ((*phi[ix+i*2]).s0).c2.im=(ka2).re*(chi).c2.im+(ka2).im*(chi).c2.re;;
      ((*phi[ix+1+i*2]).s0).c0.re=((*s).s0).c0.re-((*s).s3).c0.re; ((*phi[ix+1+i*2]).s0).c0.im=((*s).s0).c0.im-((*s).s3).c0.im; ((*phi[ix+1+i*2]).s0).c1.re=((*s).s0).c1.re-((*s).s3).c1.re; ((*phi[ix+1+i*2]).s0).c1.im=((*s).s0).c1.im-((*s).s3).c1.im; ((*phi[ix+1+i*2]).s0).c2.re=((*s).s0).c2.re-((*s).s3).c2.re; ((*phi[ix+1+i*2]).s0).c2.im=((*s).s0).c2.im-((*s).s3).c2.im;;
       iU++;
       s++;
    }
    s=save_s;
    iU=save_iU;
    for(i = 0; i < 128; i++){
      (psi).c0.re=((*s).s1).c0.re-((*s).s2).c0.re; (psi).c0.im=((*s).s1).c0.im-((*s).s2).c0.im; (psi).c1.re=((*s).s1).c1.re-((*s).s2).c1.re; (psi).c1.im=((*s).s1).c1.im-((*s).s2).c1.im; (psi).c2.re=((*s).s1).c2.re-((*s).s2).c2.re; (psi).c2.im=((*s).s1).c2.im-((*s).s2).c2.im;;
      (chi).c0.re= ((*iU)).c00.re*(psi).c0.re-((*iU)).c00.im*(psi).c0.im +((*iU)).c01.re*(psi).c1.re-((*iU)).c01.im*(psi).c1.im +((*iU)).c02.re*(psi).c2.re-((*iU)).c02.im*(psi).c2.im; (chi).c0.im= ((*iU)).c00.re*(psi).c0.im+((*iU)).c00.im*(psi).c0.re +((*iU)).c01.re*(psi).c1.im+((*iU)).c01.im*(psi).c1.re +((*iU)).c02.re*(psi).c2.im+((*iU)).c02.im*(psi).c2.re; (chi).c1.re= ((*iU)).c10.re*(psi).c0.re-((*iU)).c10.im*(psi).c0.im +((*iU)).c11.re*(psi).c1.re-((*iU)).c11.im*(psi).c1.im +((*iU)).c12.re*(psi).c2.re-((*iU)).c12.im*(psi).c2.im; (chi).c1.im= ((*iU)).c10.re*(psi).c0.im+((*iU)).c10.im*(psi).c0.re +((*iU)).c11.re*(psi).c1.im+((*iU)).c11.im*(psi).c1.re +((*iU)).c12.re*(psi).c2.im+((*iU)).c12.im*(psi).c2.re; (chi).c2.re= ((*iU)).c20.re*(psi).c0.re-((*iU)).c20.im*(psi).c0.im +((*iU)).c21.re*(psi).c1.re-((*iU)).c21.im*(psi).c1.im +((*iU)).c22.re*(psi).c2.re-((*iU)).c22.im*(psi).c2.im; (chi).c2.im= ((*iU)).c20.re*(psi).c0.im+((*iU)).c20.im*(psi).c0.re +((*iU)).c21.re*(psi).c1.im+((*iU)).c21.im*(psi).c1.re +((*iU)).c22.re*(psi).c2.im+((*iU)).c22.im*(psi).c2.re;;
      ((*phi[ix+i*2]).s1).c0.re=(ka2).re*(chi).c0.re-(ka2).im*(chi).c0.im; ((*phi[ix+i*2]).s1).c0.im=(ka2).re*(chi).c0.im+(ka2).im*(chi).c0.re; ((*phi[ix+i*2]).s1).c1.re=(ka2).re*(chi).c1.re-(ka2).im*(chi).c1.im; ((*phi[ix+i*2]).s1).c1.im=(ka2).re*(chi).c1.im+(ka2).im*(chi).c1.re; ((*phi[ix+i*2]).s1).c2.re=(ka2).re*(chi).c2.re-(ka2).im*(chi).c2.im; ((*phi[ix+i*2]).s1).c2.im=(ka2).re*(chi).c2.im+(ka2).im*(chi).c2.re;;
      iU++;
      ((*phi[ix+1+i*2]).s1).c0.re=((*s).s1).c0.re+((*s).s2).c0.re; ((*phi[ix+1+i*2]).s1).c0.im=((*s).s1).c0.im+((*s).s2).c0.im; ((*phi[ix+1+i*2]).s1).c1.re=((*s).s1).c1.re+((*s).s2).c1.re; ((*phi[ix+1+i*2]).s1).c1.im=((*s).s1).c1.im+((*s).s2).c1.im; ((*phi[ix+1+i*2]).s1).c2.re=((*s).s1).c2.re+((*s).s2).c2.re; ((*phi[ix+1+i*2]).s1).c2.im=((*s).s1).c2.im+((*s).s2).c2.im;;
      s++;
    }
   ix+=131072;
    s=k;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[3];
    }
    else {
      iU = g_gauge_field_copy2[3]+131072/2;
    }
    s+=j;
    iU+=j;
    save_s=s;
    save_iU=iU;
    for(i = 0; i < 128; i++){
      (psi).c0.re=((*s).s0).c0.re-((*s).s2).c0.im; (psi).c0.im=((*s).s0).c0.im+((*s).s2).c0.re; (psi).c1.re=((*s).s0).c1.re-((*s).s2).c1.im; (psi).c1.im=((*s).s0).c1.im+((*s).s2).c1.re; (psi).c2.re=((*s).s0).c2.re-((*s).s2).c2.im; (psi).c2.im=((*s).s0).c2.im+((*s).s2).c2.re;;
      (chi).c0.re= ((*iU)).c00.re*(psi).c0.re-((*iU)).c00.im*(psi).c0.im +((*iU)).c01.re*(psi).c1.re-((*iU)).c01.im*(psi).c1.im +((*iU)).c02.re*(psi).c2.re-((*iU)).c02.im*(psi).c2.im; (chi).c0.im= ((*iU)).c00.re*(psi).c0.im+((*iU)).c00.im*(psi).c0.re +((*iU)).c01.re*(psi).c1.im+((*iU)).c01.im*(psi).c1.re +((*iU)).c02.re*(psi).c2.im+((*iU)).c02.im*(psi).c2.re; (chi).c1.re= ((*iU)).c10.re*(psi).c0.re-((*iU)).c10.im*(psi).c0.im +((*iU)).c11.re*(psi).c1.re-((*iU)).c11.im*(psi).c1.im +((*iU)).c12.re*(psi).c2.re-((*iU)).c12.im*(psi).c2.im; (chi).c1.im= ((*iU)).c10.re*(psi).c0.im+((*iU)).c10.im*(psi).c0.re +((*iU)).c11.re*(psi).c1.im+((*iU)).c11.im*(psi).c1.re +((*iU)).c12.re*(psi).c2.im+((*iU)).c12.im*(psi).c2.re; (chi).c2.re= ((*iU)).c20.re*(psi).c0.re-((*iU)).c20.im*(psi).c0.im +((*iU)).c21.re*(psi).c1.re-((*iU)).c21.im*(psi).c1.im +((*iU)).c22.re*(psi).c2.re-((*iU)).c22.im*(psi).c2.im; (chi).c2.im= ((*iU)).c20.re*(psi).c0.im+((*iU)).c20.im*(psi).c0.re +((*iU)).c21.re*(psi).c1.im+((*iU)).c21.im*(psi).c1.re +((*iU)).c22.re*(psi).c2.im+((*iU)).c22.im*(psi).c2.re;;
      ((*phi[ix+i*2]).s0).c0.re=(ka3).re*(chi).c0.re-(ka3).im*(chi).c0.im; ((*phi[ix+i*2]).s0).c0.im=(ka3).re*(chi).c0.im+(ka3).im*(chi).c0.re; ((*phi[ix+i*2]).s0).c1.re=(ka3).re*(chi).c1.re-(ka3).im*(chi).c1.im; ((*phi[ix+i*2]).s0).c1.im=(ka3).re*(chi).c1.im+(ka3).im*(chi).c1.re; ((*phi[ix+i*2]).s0).c2.re=(ka3).re*(chi).c2.re-(ka3).im*(chi).c2.im; ((*phi[ix+i*2]).s0).c2.im=(ka3).re*(chi).c2.im+(ka3).im*(chi).c2.re;;
      iU++;
      ((*phi[ix+1+i*2]).s0).c0.re=((*s).s0).c0.re+((*s).s2).c0.im; ((*phi[ix+1+i*2]).s0).c0.im=((*s).s0).c0.im-((*s).s2).c0.re; ((*phi[ix+1+i*2]).s0).c1.re=((*s).s0).c1.re+((*s).s2).c1.im; ((*phi[ix+1+i*2]).s0).c1.im=((*s).s0).c1.im-((*s).s2).c1.re; ((*phi[ix+1+i*2]).s0).c2.re=((*s).s0).c2.re+((*s).s2).c2.im; ((*phi[ix+1+i*2]).s0).c2.im=((*s).s0).c2.im-((*s).s2).c2.re;;
      s++;
    }
    s=save_s;
    iU=save_iU;
    for(i = 0; i < 128; i++){
      (psi).c0.re=((*s).s1).c0.re+((*s).s3).c0.im; (psi).c0.im=((*s).s1).c0.im-((*s).s3).c0.re; (psi).c1.re=((*s).s1).c1.re+((*s).s3).c1.im; (psi).c1.im=((*s).s1).c1.im-((*s).s3).c1.re; (psi).c2.re=((*s).s1).c2.re+((*s).s3).c2.im; (psi).c2.im=((*s).s1).c2.im-((*s).s3).c2.re;;
      (chi).c0.re= ((*iU)).c00.re*(psi).c0.re-((*iU)).c00.im*(psi).c0.im +((*iU)).c01.re*(psi).c1.re-((*iU)).c01.im*(psi).c1.im +((*iU)).c02.re*(psi).c2.re-((*iU)).c02.im*(psi).c2.im; (chi).c0.im= ((*iU)).c00.re*(psi).c0.im+((*iU)).c00.im*(psi).c0.re +((*iU)).c01.re*(psi).c1.im+((*iU)).c01.im*(psi).c1.re +((*iU)).c02.re*(psi).c2.im+((*iU)).c02.im*(psi).c2.re; (chi).c1.re= ((*iU)).c10.re*(psi).c0.re-((*iU)).c10.im*(psi).c0.im +((*iU)).c11.re*(psi).c1.re-((*iU)).c11.im*(psi).c1.im +((*iU)).c12.re*(psi).c2.re-((*iU)).c12.im*(psi).c2.im; (chi).c1.im= ((*iU)).c10.re*(psi).c0.im+((*iU)).c10.im*(psi).c0.re +((*iU)).c11.re*(psi).c1.im+((*iU)).c11.im*(psi).c1.re +((*iU)).c12.re*(psi).c2.im+((*iU)).c12.im*(psi).c2.re; (chi).c2.re= ((*iU)).c20.re*(psi).c0.re-((*iU)).c20.im*(psi).c0.im +((*iU)).c21.re*(psi).c1.re-((*iU)).c21.im*(psi).c1.im +((*iU)).c22.re*(psi).c2.re-((*iU)).c22.im*(psi).c2.im; (chi).c2.im= ((*iU)).c20.re*(psi).c0.im+((*iU)).c20.im*(psi).c0.re +((*iU)).c21.re*(psi).c1.im+((*iU)).c21.im*(psi).c1.re +((*iU)).c22.re*(psi).c2.im+((*iU)).c22.im*(psi).c2.re;;
      ((*phi[ix+i*2]).s1).c0.re=(ka3).re*(chi).c0.re-(ka3).im*(chi).c0.im; ((*phi[ix+i*2]).s1).c0.im=(ka3).re*(chi).c0.im+(ka3).im*(chi).c0.re; ((*phi[ix+i*2]).s1).c1.re=(ka3).re*(chi).c1.re-(ka3).im*(chi).c1.im; ((*phi[ix+i*2]).s1).c1.im=(ka3).re*(chi).c1.im+(ka3).im*(chi).c1.re; ((*phi[ix+i*2]).s1).c2.re=(ka3).re*(chi).c2.re-(ka3).im*(chi).c2.im; ((*phi[ix+i*2]).s1).c2.im=(ka3).re*(chi).c2.im+(ka3).im*(chi).c2.re;;
      iU++;
      ((*phi[ix+1+i*2]).s1).c0.re=((*s).s1).c0.re-((*s).s3).c0.im; ((*phi[ix+1+i*2]).s1).c0.im=((*s).s1).c0.im+((*s).s3).c0.re; ((*phi[ix+1+i*2]).s1).c1.re=((*s).s1).c1.re-((*s).s3).c1.im; ((*phi[ix+1+i*2]).s1).c1.im=((*s).s1).c1.im+((*s).s3).c1.re; ((*phi[ix+1+i*2]).s1).c2.re=((*s).s1).c2.re-((*s).s3).c2.im; ((*phi[ix+1+i*2]).s1).c2.im=((*s).s1).c2.im+((*s).s3).c2.re;;
      s++;
    }
  }
}
#pragma omp parallel num_threads(NBT)
{
#pragma omp for private(j, iU, phi)
   for(j=0; j<(131072)/2; j+=128){
    s = l;
    phi = NBPointer[2 + ieo];
    if(ieo == 0) {
      iU = g_gauge_field_copy2[0]+131072/2;
    }
    else {
      iU = g_gauge_field_copy2[0];
    }
    ix = j*2;
    s+=j;
    iU+=j;
    save_s=s;
    save_iU=iU;
    for(i = 0; i < 128; i++){
      (chi).c0.re= ((*iU)).c00.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c00.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c10.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c10.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c20.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c20.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c0.im= ((*iU)).c00.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c00.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c10.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c10.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c20.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c20.im*((*phi[ix+1+i*2]).s0).c2.re; (chi).c1.re= ((*iU)).c01.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c01.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c11.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c11.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c21.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c21.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c1.im= ((*iU)).c01.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c01.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c11.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c11.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c21.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c21.im*((*phi[ix+1+i*2]).s0).c2.re; (chi).c2.re= ((*iU)).c02.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c02.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c12.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c12.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c22.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c22.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c2.im= ((*iU)).c02.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c02.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c12.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c12.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c22.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c22.im*((*phi[ix+1+i*2]).s0).c2.re;;
      (psi).c0.re=(ka0).re*(chi).c0.re+(ka0).im*(chi).c0.im; (psi).c0.im=(ka0).re*(chi).c0.im-(ka0).im*(chi).c0.re; (psi).c1.re=(ka0).re*(chi).c1.re+(ka0).im*(chi).c1.im; (psi).c1.im=(ka0).re*(chi).c1.im-(ka0).im*(chi).c1.re; (psi).c2.re=(ka0).re*(chi).c2.re+(ka0).im*(chi).c2.im; (psi).c2.im=(ka0).re*(chi).c2.im-(ka0).im*(chi).c2.re;;
      ((*s).s0).c0.re=((*phi[ix+i*2]).s0).c0.re+(psi).c0.re; ((*s).s0).c0.im=((*phi[ix+i*2]).s0).c0.im+(psi).c0.im; ((*s).s0).c1.re=((*phi[ix+i*2]).s0).c1.re+(psi).c1.re; ((*s).s0).c1.im=((*phi[ix+i*2]).s0).c1.im+(psi).c1.im; ((*s).s0).c2.re=((*phi[ix+i*2]).s0).c2.re+(psi).c2.re; ((*s).s0).c2.im=((*phi[ix+i*2]).s0).c2.im+(psi).c2.im;;
      ((*s).s2).c0.re=((*phi[ix+i*2]).s0).c0.re-(psi).c0.re; ((*s).s2).c0.im=((*phi[ix+i*2]).s0).c0.im-(psi).c0.im; ((*s).s2).c1.re=((*phi[ix+i*2]).s0).c1.re-(psi).c1.re; ((*s).s2).c1.im=((*phi[ix+i*2]).s0).c1.im-(psi).c1.im; ((*s).s2).c2.re=((*phi[ix+i*2]).s0).c2.re-(psi).c2.re; ((*s).s2).c2.im=((*phi[ix+i*2]).s0).c2.im-(psi).c2.im;;
      iU++;
      s++;
    }
    s = save_s;
    iU = save_iU;
    for(i = 0; i < 128; i++){
      (chi).c0.re= ((*iU)).c00.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c00.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c10.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c10.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c20.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c20.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c0.im= ((*iU)).c00.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c00.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c10.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c10.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c20.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c20.im*((*phi[ix+1+i*2]).s1).c2.re; (chi).c1.re= ((*iU)).c01.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c01.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c11.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c11.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c21.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c21.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c1.im= ((*iU)).c01.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c01.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c11.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c11.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c21.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c21.im*((*phi[ix+1+i*2]).s1).c2.re; (chi).c2.re= ((*iU)).c02.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c02.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c12.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c12.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c22.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c22.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c2.im= ((*iU)).c02.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c02.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c12.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c12.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c22.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c22.im*((*phi[ix+1+i*2]).s1).c2.re;;
      (psi).c0.re=(ka0).re*(chi).c0.re+(ka0).im*(chi).c0.im; (psi).c0.im=(ka0).re*(chi).c0.im-(ka0).im*(chi).c0.re; (psi).c1.re=(ka0).re*(chi).c1.re+(ka0).im*(chi).c1.im; (psi).c1.im=(ka0).re*(chi).c1.im-(ka0).im*(chi).c1.re; (psi).c2.re=(ka0).re*(chi).c2.re+(ka0).im*(chi).c2.im; (psi).c2.im=(ka0).re*(chi).c2.im-(ka0).im*(chi).c2.re;;
      ((*s).s1).c0.re=((*phi[ix+i*2]).s1).c0.re+(psi).c0.re; ((*s).s1).c0.im=((*phi[ix+i*2]).s1).c0.im+(psi).c0.im; ((*s).s1).c1.re=((*phi[ix+i*2]).s1).c1.re+(psi).c1.re; ((*s).s1).c1.im=((*phi[ix+i*2]).s1).c1.im+(psi).c1.im; ((*s).s1).c2.re=((*phi[ix+i*2]).s1).c2.re+(psi).c2.re; ((*s).s1).c2.im=((*phi[ix+i*2]).s1).c2.im+(psi).c2.im;;
      ((*s).s3).c0.re=((*phi[ix+i*2]).s1).c0.re-(psi).c0.re; ((*s).s3).c0.im=((*phi[ix+i*2]).s1).c0.im-(psi).c0.im; ((*s).s3).c1.re=((*phi[ix+i*2]).s1).c1.re-(psi).c1.re; ((*s).s3).c1.im=((*phi[ix+i*2]).s1).c1.im-(psi).c1.im; ((*s).s3).c2.re=((*phi[ix+i*2]).s1).c2.re-(psi).c2.re; ((*s).s3).c2.im=((*phi[ix+i*2]).s1).c2.im-(psi).c2.im;;
      iU++;
      s++;
    }
    ix+=131072;
    s = l;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[1]+131072/2;
    }
    else {
      iU = g_gauge_field_copy2[1];
    }
    s+=j;
    iU+=j;
    save_s = s;
    save_iU = iU;
    for(i = 0; i < 128; i++){
      ((*s).s0).c0.re+=((*phi[ix+i*2]).s0).c0.re; ((*s).s0).c0.im+=((*phi[ix+i*2]).s0).c0.im; ((*s).s0).c1.re+=((*phi[ix+i*2]).s0).c1.re; ((*s).s0).c1.im+=((*phi[ix+i*2]).s0).c1.im; ((*s).s0).c2.re+=((*phi[ix+i*2]).s0).c2.re; ((*s).s0).c2.im+=((*phi[ix+i*2]).s0).c2.im;;
      ((*s).s3).c0.re+=((*phi[ix+i*2]).s0).c0.im; ((*s).s3).c0.im-=((*phi[ix+i*2]).s0).c0.re; ((*s).s3).c1.re+=((*phi[ix+i*2]).s0).c1.im; ((*s).s3).c1.im-=((*phi[ix+i*2]).s0).c1.re; ((*s).s3).c2.re+=((*phi[ix+i*2]).s0).c2.im; ((*s).s3).c2.im-=((*phi[ix+i*2]).s0).c2.re;;
      (chi).c0.re= ((*iU)).c00.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c00.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c10.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c10.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c20.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c20.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c0.im= ((*iU)).c00.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c00.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c10.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c10.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c20.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c20.im*((*phi[ix+1+i*2]).s0).c2.re; (chi).c1.re= ((*iU)).c01.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c01.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c11.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c11.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c21.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c21.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c1.im= ((*iU)).c01.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c01.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c11.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c11.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c21.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c21.im*((*phi[ix+1+i*2]).s0).c2.re; (chi).c2.re= ((*iU)).c02.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c02.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c12.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c12.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c22.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c22.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c2.im= ((*iU)).c02.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c02.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c12.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c12.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c22.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c22.im*((*phi[ix+1+i*2]).s0).c2.re;;
      (psi).c0.re=(ka1).re*(chi).c0.re+(ka1).im*(chi).c0.im; (psi).c0.im=(ka1).re*(chi).c0.im-(ka1).im*(chi).c0.re; (psi).c1.re=(ka1).re*(chi).c1.re+(ka1).im*(chi).c1.im; (psi).c1.im=(ka1).re*(chi).c1.im-(ka1).im*(chi).c1.re; (psi).c2.re=(ka1).re*(chi).c2.re+(ka1).im*(chi).c2.im; (psi).c2.im=(ka1).re*(chi).c2.im-(ka1).im*(chi).c2.re;;
      ((*s).s0).c0.re+=(psi).c0.re; ((*s).s0).c0.im+=(psi).c0.im; ((*s).s0).c1.re+=(psi).c1.re; ((*s).s0).c1.im+=(psi).c1.im; ((*s).s0).c2.re+=(psi).c2.re; ((*s).s0).c2.im+=(psi).c2.im;;
      ((*s).s3).c0.re-=(psi).c0.im; ((*s).s3).c0.im+=(psi).c0.re; ((*s).s3).c1.re-=(psi).c1.im; ((*s).s3).c1.im+=(psi).c1.re; ((*s).s3).c2.re-=(psi).c2.im; ((*s).s3).c2.im+=(psi).c2.re;;
      iU++;
      s++;
    }
    s = save_s;
    iU = save_iU;
    for(i = 0; i < 128; i++){
      ((*s).s1).c0.re+=((*phi[ix+i*2]).s1).c0.re; ((*s).s1).c0.im+=((*phi[ix+i*2]).s1).c0.im; ((*s).s1).c1.re+=((*phi[ix+i*2]).s1).c1.re; ((*s).s1).c1.im+=((*phi[ix+i*2]).s1).c1.im; ((*s).s1).c2.re+=((*phi[ix+i*2]).s1).c2.re; ((*s).s1).c2.im+=((*phi[ix+i*2]).s1).c2.im;;
      ((*s).s2).c0.re+=((*phi[ix+i*2]).s1).c0.im; ((*s).s2).c0.im-=((*phi[ix+i*2]).s1).c0.re; ((*s).s2).c1.re+=((*phi[ix+i*2]).s1).c1.im; ((*s).s2).c1.im-=((*phi[ix+i*2]).s1).c1.re; ((*s).s2).c2.re+=((*phi[ix+i*2]).s1).c2.im; ((*s).s2).c2.im-=((*phi[ix+i*2]).s1).c2.re;;
      (chi).c0.re= ((*iU)).c00.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c00.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c10.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c10.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c20.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c20.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c0.im= ((*iU)).c00.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c00.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c10.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c10.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c20.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c20.im*((*phi[ix+1+i*2]).s1).c2.re; (chi).c1.re= ((*iU)).c01.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c01.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c11.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c11.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c21.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c21.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c1.im= ((*iU)).c01.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c01.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c11.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c11.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c21.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c21.im*((*phi[ix+1+i*2]).s1).c2.re; (chi).c2.re= ((*iU)).c02.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c02.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c12.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c12.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c22.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c22.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c2.im= ((*iU)).c02.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c02.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c12.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c12.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c22.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c22.im*((*phi[ix+1+i*2]).s1).c2.re;;
      (psi).c0.re=(ka1).re*(chi).c0.re+(ka1).im*(chi).c0.im; (psi).c0.im=(ka1).re*(chi).c0.im-(ka1).im*(chi).c0.re; (psi).c1.re=(ka1).re*(chi).c1.re+(ka1).im*(chi).c1.im; (psi).c1.im=(ka1).re*(chi).c1.im-(ka1).im*(chi).c1.re; (psi).c2.re=(ka1).re*(chi).c2.re+(ka1).im*(chi).c2.im; (psi).c2.im=(ka1).re*(chi).c2.im-(ka1).im*(chi).c2.re;;
      ((*s).s1).c0.re+=(psi).c0.re; ((*s).s1).c0.im+=(psi).c0.im; ((*s).s1).c1.re+=(psi).c1.re; ((*s).s1).c1.im+=(psi).c1.im; ((*s).s1).c2.re+=(psi).c2.re; ((*s).s1).c2.im+=(psi).c2.im;;
      ((*s).s2).c0.re-=(psi).c0.im; ((*s).s2).c0.im+=(psi).c0.re; ((*s).s2).c1.re-=(psi).c1.im; ((*s).s2).c1.im+=(psi).c1.re; ((*s).s2).c2.re-=(psi).c2.im; ((*s).s2).c2.im+=(psi).c2.re;;
      iU++;
      s++;
    }
    ix+=131072;
    s = l;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[2]+131072/2;
    }
    else {
      iU = g_gauge_field_copy2[2];
    }
    s+=j;
    iU+=j;
    save_s=s;
    save_iU=iU;
    for(i = 0; i < 128; i++){
      ((*s).s0).c0.re+=((*phi[ix+i*2]).s0).c0.re; ((*s).s0).c0.im+=((*phi[ix+i*2]).s0).c0.im; ((*s).s0).c1.re+=((*phi[ix+i*2]).s0).c1.re; ((*s).s0).c1.im+=((*phi[ix+i*2]).s0).c1.im; ((*s).s0).c2.re+=((*phi[ix+i*2]).s0).c2.re; ((*s).s0).c2.im+=((*phi[ix+i*2]).s0).c2.im;;
      ((*s).s3).c0.re+=((*phi[ix+i*2]).s0).c0.re; ((*s).s3).c0.im+=((*phi[ix+i*2]).s0).c0.im; ((*s).s3).c1.re+=((*phi[ix+i*2]).s0).c1.re; ((*s).s3).c1.im+=((*phi[ix+i*2]).s0).c1.im; ((*s).s3).c2.re+=((*phi[ix+i*2]).s0).c2.re; ((*s).s3).c2.im+=((*phi[ix+i*2]).s0).c2.im;;
      (chi).c0.re= ((*iU)).c00.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c00.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c10.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c10.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c20.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c20.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c0.im= ((*iU)).c00.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c00.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c10.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c10.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c20.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c20.im*((*phi[ix+1+i*2]).s0).c2.re; (chi).c1.re= ((*iU)).c01.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c01.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c11.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c11.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c21.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c21.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c1.im= ((*iU)).c01.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c01.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c11.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c11.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c21.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c21.im*((*phi[ix+1+i*2]).s0).c2.re; (chi).c2.re= ((*iU)).c02.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c02.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c12.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c12.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c22.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c22.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c2.im= ((*iU)).c02.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c02.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c12.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c12.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c22.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c22.im*((*phi[ix+1+i*2]).s0).c2.re;;
      (psi).c0.re=(ka2).re*(chi).c0.re+(ka2).im*(chi).c0.im; (psi).c0.im=(ka2).re*(chi).c0.im-(ka2).im*(chi).c0.re; (psi).c1.re=(ka2).re*(chi).c1.re+(ka2).im*(chi).c1.im; (psi).c1.im=(ka2).re*(chi).c1.im-(ka2).im*(chi).c1.re; (psi).c2.re=(ka2).re*(chi).c2.re+(ka2).im*(chi).c2.im; (psi).c2.im=(ka2).re*(chi).c2.im-(ka2).im*(chi).c2.re;;
      ((*s).s0).c0.re+=(psi).c0.re; ((*s).s0).c0.im+=(psi).c0.im; ((*s).s0).c1.re+=(psi).c1.re; ((*s).s0).c1.im+=(psi).c1.im; ((*s).s0).c2.re+=(psi).c2.re; ((*s).s0).c2.im+=(psi).c2.im;;
      ((*s).s3).c0.re-=(psi).c0.re; ((*s).s3).c0.im-=(psi).c0.im; ((*s).s3).c1.re-=(psi).c1.re; ((*s).s3).c1.im-=(psi).c1.im; ((*s).s3).c2.re-=(psi).c2.re; ((*s).s3).c2.im-=(psi).c2.im;;
      iU++;
      s++;
    }
    s=save_s;
    iU=save_iU;
    for(i = 0; i < 128; i++){
      ((*s).s1).c0.re+=((*phi[ix+i*2]).s1).c0.re; ((*s).s1).c0.im+=((*phi[ix+i*2]).s1).c0.im; ((*s).s1).c1.re+=((*phi[ix+i*2]).s1).c1.re; ((*s).s1).c1.im+=((*phi[ix+i*2]).s1).c1.im; ((*s).s1).c2.re+=((*phi[ix+i*2]).s1).c2.re; ((*s).s1).c2.im+=((*phi[ix+i*2]).s1).c2.im;;
      ((*s).s2).c0.re-=((*phi[ix+i*2]).s1).c0.re; ((*s).s2).c0.im-=((*phi[ix+i*2]).s1).c0.im; ((*s).s2).c1.re-=((*phi[ix+i*2]).s1).c1.re; ((*s).s2).c1.im-=((*phi[ix+i*2]).s1).c1.im; ((*s).s2).c2.re-=((*phi[ix+i*2]).s1).c2.re; ((*s).s2).c2.im-=((*phi[ix+i*2]).s1).c2.im;;
      (chi).c0.re= ((*iU)).c00.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c00.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c10.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c10.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c20.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c20.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c0.im= ((*iU)).c00.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c00.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c10.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c10.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c20.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c20.im*((*phi[ix+1+i*2]).s1).c2.re; (chi).c1.re= ((*iU)).c01.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c01.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c11.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c11.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c21.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c21.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c1.im= ((*iU)).c01.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c01.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c11.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c11.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c21.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c21.im*((*phi[ix+1+i*2]).s1).c2.re; (chi).c2.re= ((*iU)).c02.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c02.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c12.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c12.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c22.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c22.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c2.im= ((*iU)).c02.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c02.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c12.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c12.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c22.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c22.im*((*phi[ix+1+i*2]).s1).c2.re;;
      (psi).c0.re=(ka2).re*(chi).c0.re+(ka2).im*(chi).c0.im; (psi).c0.im=(ka2).re*(chi).c0.im-(ka2).im*(chi).c0.re; (psi).c1.re=(ka2).re*(chi).c1.re+(ka2).im*(chi).c1.im; (psi).c1.im=(ka2).re*(chi).c1.im-(ka2).im*(chi).c1.re; (psi).c2.re=(ka2).re*(chi).c2.re+(ka2).im*(chi).c2.im; (psi).c2.im=(ka2).re*(chi).c2.im-(ka2).im*(chi).c2.re;;
      ((*s).s1).c0.re+=(psi).c0.re; ((*s).s1).c0.im+=(psi).c0.im; ((*s).s1).c1.re+=(psi).c1.re; ((*s).s1).c1.im+=(psi).c1.im; ((*s).s1).c2.re+=(psi).c2.re; ((*s).s1).c2.im+=(psi).c2.im;;
      ((*s).s2).c0.re+=(psi).c0.re; ((*s).s2).c0.im+=(psi).c0.im; ((*s).s2).c1.re+=(psi).c1.re; ((*s).s2).c1.im+=(psi).c1.im; ((*s).s2).c2.re+=(psi).c2.re; ((*s).s2).c2.im+=(psi).c2.im;;
      iU++;
      s++;
    }
    ix+=131072;
    s = l;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[3]+131072/2;
    }
    else {
      iU = g_gauge_field_copy2[3];
    }
    s+=j;
    iU+=j;
    save_s=s;
    save_iU=iU;
    for(i = 0; i < 128; i++){
      ((*s).s0).c0.re+=((*phi[ix+i*2]).s0).c0.re; ((*s).s0).c0.im+=((*phi[ix+i*2]).s0).c0.im; ((*s).s0).c1.re+=((*phi[ix+i*2]).s0).c1.re; ((*s).s0).c1.im+=((*phi[ix+i*2]).s0).c1.im; ((*s).s0).c2.re+=((*phi[ix+i*2]).s0).c2.re; ((*s).s0).c2.im+=((*phi[ix+i*2]).s0).c2.im;;
      ((*s).s2).c0.re+=((*phi[ix+i*2]).s0).c0.im; ((*s).s2).c0.im-=((*phi[ix+i*2]).s0).c0.re; ((*s).s2).c1.re+=((*phi[ix+i*2]).s0).c1.im; ((*s).s2).c1.im-=((*phi[ix+i*2]).s0).c1.re; ((*s).s2).c2.re+=((*phi[ix+i*2]).s0).c2.im; ((*s).s2).c2.im-=((*phi[ix+i*2]).s0).c2.re;;
      (chi).c0.re= ((*iU)).c00.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c00.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c10.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c10.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c20.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c20.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c0.im= ((*iU)).c00.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c00.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c10.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c10.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c20.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c20.im*((*phi[ix+1+i*2]).s0).c2.re; (chi).c1.re= ((*iU)).c01.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c01.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c11.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c11.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c21.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c21.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c1.im= ((*iU)).c01.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c01.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c11.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c11.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c21.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c21.im*((*phi[ix+1+i*2]).s0).c2.re; (chi).c2.re= ((*iU)).c02.re*((*phi[ix+1+i*2]).s0).c0.re+((*iU)).c02.im*((*phi[ix+1+i*2]).s0).c0.im +((*iU)).c12.re*((*phi[ix+1+i*2]).s0).c1.re+((*iU)).c12.im*((*phi[ix+1+i*2]).s0).c1.im +((*iU)).c22.re*((*phi[ix+1+i*2]).s0).c2.re+((*iU)).c22.im*((*phi[ix+1+i*2]).s0).c2.im; (chi).c2.im= ((*iU)).c02.re*((*phi[ix+1+i*2]).s0).c0.im-((*iU)).c02.im*((*phi[ix+1+i*2]).s0).c0.re +((*iU)).c12.re*((*phi[ix+1+i*2]).s0).c1.im-((*iU)).c12.im*((*phi[ix+1+i*2]).s0).c1.re +((*iU)).c22.re*((*phi[ix+1+i*2]).s0).c2.im-((*iU)).c22.im*((*phi[ix+1+i*2]).s0).c2.re;;
      (psi).c0.re=(ka3).re*(chi).c0.re+(ka3).im*(chi).c0.im; (psi).c0.im=(ka3).re*(chi).c0.im-(ka3).im*(chi).c0.re; (psi).c1.re=(ka3).re*(chi).c1.re+(ka3).im*(chi).c1.im; (psi).c1.im=(ka3).re*(chi).c1.im-(ka3).im*(chi).c1.re; (psi).c2.re=(ka3).re*(chi).c2.re+(ka3).im*(chi).c2.im; (psi).c2.im=(ka3).re*(chi).c2.im-(ka3).im*(chi).c2.re;;
      ((*s).s0).c0.re+=(psi).c0.re; ((*s).s0).c0.im+=(psi).c0.im; ((*s).s0).c1.re+=(psi).c1.re; ((*s).s0).c1.im+=(psi).c1.im; ((*s).s0).c2.re+=(psi).c2.re; ((*s).s0).c2.im+=(psi).c2.im;;
      ((*s).s2).c0.re-=(psi).c0.im; ((*s).s2).c0.im+=(psi).c0.re; ((*s).s2).c1.re-=(psi).c1.im; ((*s).s2).c1.im+=(psi).c1.re; ((*s).s2).c2.re-=(psi).c2.im; ((*s).s2).c2.im+=(psi).c2.re;;
      iU++;
      s++;
    }
    s=save_s;
    iU=save_iU;
    for(i = 0; i < 128; i++){
      ((*s).s1).c0.re+=((*phi[ix+i*2]).s1).c0.re; ((*s).s1).c0.im+=((*phi[ix+i*2]).s1).c0.im; ((*s).s1).c1.re+=((*phi[ix+i*2]).s1).c1.re; ((*s).s1).c1.im+=((*phi[ix+i*2]).s1).c1.im; ((*s).s1).c2.re+=((*phi[ix+i*2]).s1).c2.re; ((*s).s1).c2.im+=((*phi[ix+i*2]).s1).c2.im;;
      ((*s).s3).c0.re-=((*phi[ix+i*2]).s1).c0.im; ((*s).s3).c0.im+=((*phi[ix+i*2]).s1).c0.re; ((*s).s3).c1.re-=((*phi[ix+i*2]).s1).c1.im; ((*s).s3).c1.im+=((*phi[ix+i*2]).s1).c1.re; ((*s).s3).c2.re-=((*phi[ix+i*2]).s1).c2.im; ((*s).s3).c2.im+=((*phi[ix+i*2]).s1).c2.re;;
      (chi).c0.re= ((*iU)).c00.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c00.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c10.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c10.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c20.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c20.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c0.im= ((*iU)).c00.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c00.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c10.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c10.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c20.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c20.im*((*phi[ix+1+i*2]).s1).c2.re; (chi).c1.re= ((*iU)).c01.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c01.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c11.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c11.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c21.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c21.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c1.im= ((*iU)).c01.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c01.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c11.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c11.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c21.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c21.im*((*phi[ix+1+i*2]).s1).c2.re; (chi).c2.re= ((*iU)).c02.re*((*phi[ix+1+i*2]).s1).c0.re+((*iU)).c02.im*((*phi[ix+1+i*2]).s1).c0.im +((*iU)).c12.re*((*phi[ix+1+i*2]).s1).c1.re+((*iU)).c12.im*((*phi[ix+1+i*2]).s1).c1.im +((*iU)).c22.re*((*phi[ix+1+i*2]).s1).c2.re+((*iU)).c22.im*((*phi[ix+1+i*2]).s1).c2.im; (chi).c2.im= ((*iU)).c02.re*((*phi[ix+1+i*2]).s1).c0.im-((*iU)).c02.im*((*phi[ix+1+i*2]).s1).c0.re +((*iU)).c12.re*((*phi[ix+1+i*2]).s1).c1.im-((*iU)).c12.im*((*phi[ix+1+i*2]).s1).c1.re +((*iU)).c22.re*((*phi[ix+1+i*2]).s1).c2.im-((*iU)).c22.im*((*phi[ix+1+i*2]).s1).c2.re;;
      (psi).c0.re=(ka3).re*(chi).c0.re+(ka3).im*(chi).c0.im; (psi).c0.im=(ka3).re*(chi).c0.im-(ka3).im*(chi).c0.re; (psi).c1.re=(ka3).re*(chi).c1.re+(ka3).im*(chi).c1.im; (psi).c1.im=(ka3).re*(chi).c1.im-(ka3).im*(chi).c1.re; (psi).c2.re=(ka3).re*(chi).c2.re+(ka3).im*(chi).c2.im; (psi).c2.im=(ka3).re*(chi).c2.im-(ka3).im*(chi).c2.re;;
      ((*s).s1).c0.re+=(psi).c0.re; ((*s).s1).c0.im+=(psi).c0.im; ((*s).s1).c1.re+=(psi).c1.re; ((*s).s1).c1.im+=(psi).c1.im; ((*s).s1).c2.re+=(psi).c2.re; ((*s).s1).c2.im+=(psi).c2.im;;
      ((*s).s3).c0.re+=(psi).c0.im; ((*s).s3).c0.im-=(psi).c0.re; ((*s).s3).c1.re+=(psi).c1.im; ((*s).s3).c1.im-=(psi).c1.re; ((*s).s3).c2.re+=(psi).c2.im; ((*s).s3).c2.im-=(psi).c2.re;;
      iU++;
      s++;
    }
   }
 }
current=time((time_t *)0)-current;
global+=current;
}
